using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Resources;
using System.IO;
using Mapack;
using System.Diagnostics;



namespace Stairway
{
    public partial class ChartCalc : Form
    {
        //SQL-string for connecting to SQL-server
        //string connStr = "Server=.\\SQLEXPRESS;AttachDbFilename=C:\\Program files\\Microsoft SQL Server\\MSSQL.1\\MSSQL\\Data\\StairWay.mdf;Database=StairWay;Trusted_Connection=Yes;";

        //Initializing variables
        double[] trafficAvg;
        string trafficString;
        double[] trafficStdDev;
        

        int numOfTr;

        double[] facadeAvg;
        string facadeString;
        double[] facadeStdDev;
        int numOfFa;

        Graphs graph;

        double buildings;
        MaterialData mat;
        WallData wallData;
        WindowData windowData;
        RevData revData;
        OutdoorData outData;

        int calcMeth;
        double roomVolume;
        double partitionArea;
        
        double[] revTime;
        Boolean isUsingRevData;

        double fc1n; //critical frequency panel 1
        double fc2n; //critical frequency panel 2
        double fdn;  //mass-air-mass resonance
      
        double[] freqband = new double[] { 50, 63, 80, 100, 125, 160, 200, 250, 315, 400, 500, 630, 800, 1000, 1250, 1600, 2000, 2500, 3150, 4000, 5000 };
        
        public ChartCalc()
        {
            mat = new MaterialData(2500, 60, 0.3, 0.02, 1.21, 344);
            wallData = new WallData();
            windowData = new WindowData(); 
            outData = new OutdoorData();
            isUsingRevData = false;
            revData = new RevData();
            revTime = new double[]{ 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5 };
            fc1n = 0;
            fc2n = 0;
            fdn = 0;

            

            InitializeComponent();
            this.textBoxFacadeArea.Text = (Convert.ToDouble(this.textBoxAreaWindow.Text) + Convert.ToDouble(this.textBoxAreaWall.Text)).ToString();
         

        }

        #region Button10_click show charts
        private void button10_Click(object sender, EventArgs e)
        {
            trafficAvg = null;
            trafficString = null;
            facadeAvg = null;
            facadeString = null;
            numOfFa = 0;
            numOfTr = 0;


            this.roomVolume = Convert.ToDouble(this.textBoxRoomVolume.Text);
            this.partitionArea = Convert.ToDouble(this.textBoxFacadeArea.Text);
            if (this.checkBoxDefRevTime.Checked == true)
            {
                isUsingRevData = true;
            }
            else

            

            Console.WriteLine("button1 clicked");


            //facadeAvg = connectAndGetTableFromDBFacade();
            //facadeAvg = new double[] { 24, 24, 24, 24, 25, 36, 33, 40, 42, 42, 44, 45, 46, 49, 51, 54, 53, 53, 56, 56, 56 };

            //facadeAvg = connectAndGetFromModel();
            //trafficAvg = connectAndGetTableFromDBTraffic();
            //trafficAvg = connectAndGetFromStdSpectrum();
            //graph = new Graphs(trafficAvg, trafficStdDev, trafficString, facadeAvg, facadeStdDev, buildings, numOfFa, numOfTr,
            //Convert.ToInt32(this.textBoxTrSpeed.Text), Convert.ToInt32(this.textBoxTrSpeed2.Text));
            //graph.Show();

            try
            {
               if (this.checkBoxTraffic.Checked == false
                       && this.checkBoxFacade.Checked == false)
                    {
                        MessageBox.Show("Choose traffic or facade to view charts");
                    }
                    else
                    {

                        //traffic == true
                        //facade == true
                        if (this.checkBoxTraffic.Checked == true
                            && this.checkBoxFacade.Checked == true)
                        {
                            if (this.radioButtonStairwayFacade.Checked == true)
                            {
                                facadeAvg = connectAndGetTableFromDBFacade();
                                MessageBox.Show("Only values for default settings available from database");
                            }
                            else
                            {
                                facadeAvg = connectAndGetFromModel();
                            }
                            if (this.radioButtonStairwayTraffic.Checked == true)
                            {
                                trafficAvg = connectAndGetTableFromDBTraffic();
                                MessageBox.Show("Only values for default settings available from database");
                            }
                            else
                            {
                                trafficAvg = connectAndGetFromStdSpectrum();
                            }
                        }
                        //traffic == true
                        //facade == false
                        else if (this.checkBoxTraffic.Checked == true
                            && this.checkBoxFacade.Checked == false)
                        {
                            calcMeth = 9;
                            if (this.radioButtonStairwayTraffic.Checked == true)
                            {
                                trafficAvg = connectAndGetTableFromDBTraffic();
                                MessageBox.Show("Only values for default settings available from database");
                            }
                            else
                            {
                                trafficAvg = connectAndGetFromStdSpectrum();
                            }
                        }
                        //traffic == false
                        //facade == true
                        else if (this.checkBoxTraffic.Checked == false
                            && this.checkBoxFacade.Checked == true)
                        {
                            if (this.radioButtonStairwayFacade.Checked == true)
                            {
                                facadeAvg = connectAndGetTableFromDBFacade();
                                MessageBox.Show("Only values for default settings available from database");
                            }
                            else
                            {
                                facadeAvg = connectAndGetFromModel();
                            }
                        }
                        //traffic == false
                        //facade == false
                        else
                        {
                            MessageBox.Show("Choose traffic or facade to view charts");

                        }
                        
                   if (this.checkBoxStdSpc.Checked == true)
                        {
                            try
                            {
                                trafficAvg = new double[21];
                                double facRefTemp = buildings;
                                this.buildings = Convert.ToDouble(this.textBoxFacRef.Text);
                                trafficAvg = outData.getOutdoorData();
                                Console.WriteLine("writing from def outdoor spectrum");

                                if (this.checkBoxStdSpcAWeigted.Checked == false)
                                {
                                    trafficAvg = this.doAweight(trafficAvg);
                                }
                            }
                            catch (Exception exp)
                            {
                                Console.WriteLine(exp.Message);
                            }
                        }

                        int sylnr = 0; 
                        int opm = 0; 
                    

                        try
                        {
                            sylnr = Convert.ToInt32(this.comboBoxNumSyl.Text);
                            opm = Convert.ToInt32(this.textBoxRPM.Text);
                        }
                        catch (Exception exp)
                        {
                            Console.WriteLine(exp.Message);
                        }
                        //release only:
                        trafficStdDev = new double[] { 2.9, 2, 1.7, 1.3, 1.8, 1.6, 2.45, 2.9, 2.9, 3, 1.7, 1.2, 1.9, 1.9, 2.2, 1.9, 2.9, 3.4, 4.5, 5.2, 5.7 };
                        facadeStdDev = new double[] { 4.8, 3.5, 3.5, 5.8, 6.9, 5.7, 2.3, 3.9, 4.9, 3.8, 3.2, 3.4, 4.2, 4.8, 7.3, 6.1, 6.7, 6.0, 6.5, 6.1 };
                    
                    //Calls for the graphing form
                    graph = new Graphs(trafficAvg, trafficStdDev, trafficString, facadeAvg, facadeStdDev, buildings, numOfFa, numOfTr,
                        Convert.ToInt32(this.textBoxTrSpeed.Text), Convert.ToInt32(this.textBoxTrSpeed2.Text), calcMeth, roomVolume, 
                        partitionArea, mat, revTime, revData, isUsingRevData, fc1n, fc2n, fdn, sylnr, opm);

                    graph.Show();
                }
            }
            catch (ArgumentException exc)
            {
                Console.WriteLine(exc.Message);
            }
        }
        #endregion
        
        #region Facade GUI control
        private void radioButtonStairwayFacade_CheckedChanged(object sender, EventArgs e)
        {
            if (this.radioButtonModelFacade.Checked == true)
            {
                this.panelFacadeStairway.Visible = false;
                this.panelCalc.Visible = true;
                this.Refresh();
            }
            else
            {
                this.panelFacadeStairway.Visible = true;
                this.panelCalc.Visible = false;
                this.Refresh();
            }
        }


        private void radioButtonModelFacade_CheckedChanged(object sender, EventArgs e)
        {
            if (this.radioButtonStairwayFacade.Checked == false)
            {
                this.panelFacadeStairway.Visible = false;
                this.panelCalc.Visible = true;
                this.Refresh();
            }
            else
            {
                this.panelFacadeStairway.Visible = true;
                this.panelCalc.Visible = false;
                this.Refresh();
            }
        }
        #endregion
        
        #region Checkbox traffic and facade GUI
        private void checkBoxFacade_CheckedChanged_1(object sender, EventArgs e)
        {
            if (this.checkBoxFacade.Checked == true)
            {
                this.tabControl1.SelectedTab = this.tabPageFacade;

                if (this.checkBoxTraffic.Checked == true)
                {
                    this.tabControl1.Enabled = true;
                }
            }


            else if (this.checkBoxTraffic.Checked == false && this.checkBoxFacade.Checked == false)
            {
                this.tabControl1.Enabled = false;
            }

            else // (this.checkBoxFacade.Checked == false)
            {
                this.tabControl1.SelectedTab = this.tabPageTraffic;
                this.tabControl1.Enabled = true;
            }

            if (this.checkBoxTraffic.Checked == true || this.checkBoxFacade.Checked == true)
            {
                this.tabControl1.Enabled = true;
            }

            this.Refresh();
        }

        private void checkBoxTraffic_CheckedChanged_1(object sender, EventArgs e)
        {
            if (this.checkBoxTraffic.Checked == true)
            {
                this.tabControl1.SelectedTab = this.tabPageTraffic;

                if (this.checkBoxFacade.Checked == true)
                {
                    this.tabControl1.Enabled = true;
                }
            }

            else if (this.checkBoxTraffic.Checked == false && this.checkBoxFacade.Checked == false)
            {
                this.tabControl1.Enabled = false;
            }

            else // (this.checkBoxTraffic.Checked == false)
            {
                this.tabControl1.SelectedTab = this.tabPageFacade;
                this.tabControl1.Enabled = true;
            }

            if (this.checkBoxTraffic.Checked == true || this.checkBoxFacade.Checked == true)
            {
                this.tabControl1.Enabled = true;
            }

            this.Refresh();
        }
        #endregion

        #region Traffic GUI control
        private void radioButtonStairwayTraffic_CheckedChanged(object sender, EventArgs e)
        {
            if (this.radioButtonStairwayTraffic.Checked == false)
            {
                this.panelTrafficStairWay.Visible = false;
                this.panelTrafficStdSpectrum.Visible = true;
            }
            else
            {
                this.panelTrafficStairWay.Visible = true;
                this.panelTrafficStdSpectrum.Visible = false;
            }
            this.Refresh();
        }

        private void radioButtonStdTraffic_CheckedChanged(object sender, EventArgs e)
        {
            if (this.radioButtonStdTraffic.Checked == false)
            {
                this.panelTrafficStairWay.Visible = true;
                this.panelTrafficStdSpectrum.Visible = false;
            }
            else
            {
                this.panelTrafficStairWay.Visible = false;
                this.panelTrafficStdSpectrum.Visible = true;
            }
            this.Refresh();
        }
        #endregion

        #region Toolstrip control
        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.Application.Exit();
        }

        private void aboutStairwayToolStripMenuItem_Click(object sender, EventArgs e)
        {
            About about = new About();
            about.Show();

        }

        //new
        private void nyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChartCalc chartCalc = new ChartCalc();
            chartCalc.Show();
        }

        //save
        private void lagreSesionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string date = System.DateTime.Now.ToLongDateString();
            string time = System.DateTime.Now.ToShortTimeString();

            // If the file name is not an empty string open it for saving.
            if (saveFileDialog1.FileName != "")
            {
                try
                {
                    //System.IO.FileStream fs = (System.IO.FileStream)saveFileDialog1.OpenFile();
                    StreamWriter objWriter = new StreamWriter(saveFileDialog1.OpenFile());
                    objWriter.WriteLine(date);
                    objWriter.WriteLine(time);

                    objWriter.WriteLine("");
                    objWriter.WriteLine("*******Materialdata******");
                    objWriter.WriteLine("Glass tetthet: " + mat.gDens);
                    objWriter.WriteLine("Glass E-Modul: " + mat.gEMod);
                    objWriter.WriteLine("Glass Poissons tall: " + mat.gPoi);
                    objWriter.WriteLine("Glass tapsfaktor: " + mat.gLoss);
                    objWriter.WriteLine("Luft tetthet: " + mat.aDen);
                    objWriter.WriteLine("Luft hastighet: " + mat.aSpeed);

                    objWriter.WriteLine("");
                        
                    objWriter.WriteLine("*******Vegg data******");

                    for (int i = 0; i < wallData.wallData.Length; i++)
                    {
                        objWriter.WriteLine(freqband[i].ToString() + ": " +
                            wallData.wallData[i].ToString());
                    }

                    objWriter.WriteLine("");

                    objWriter.WriteLine("*******Vindu data******");

                    for (int i = 0; i < windowData.windowData.Length; i++)
                    {
                        objWriter.WriteLine(freqband[i].ToString() + ": " +
                            windowData.windowData[i].ToString());
                    }
                    objWriter.WriteLine("");

                    objWriter.WriteLine("*******Etterklangstid data******");

                    for (int i = 0; i < revData.revData.Length; i++)
                    {
                        objWriter.WriteLine(freqband[i].ToString() + ": " +
                            revData.revData[i].ToString());
                    }
                    objWriter.WriteLine("");
                    objWriter.WriteLine("*******Utendrsspetrum******");

                    for (int i = 0; i < this.outData.outdoorData.Length; i++)
                    {
                        objWriter.WriteLine(freqband[i].ToString() + ": " +
                            outData.outdoorData[i].ToString());
                    }
                    objWriter.WriteLine("");

                    objWriter.WriteLine("*******Rom dimensjoner******");
                    objWriter.WriteLine("*******Rom volum****************");
                    objWriter.WriteLine(this.roomVolume.ToString());
                    objWriter.WriteLine("*******Skille areal****************");
                    objWriter.WriteLine(this.partitionArea.ToString());
                    objWriter.WriteLine("*******Vindu sidekant 1****************");
                    objWriter.WriteLine(this.textBoxWinDimA.Text.ToString());
                    objWriter.WriteLine("*******Vindu sidekant 2****************");
                    objWriter.WriteLine(this.textBoxWinDimB.Text.ToString());
                    objWriter.WriteLine("*******Vegg areal****************");
                    objWriter.WriteLine(this.textBoxAreaWall.Text.ToString());


                    objWriter.Close();
                }
                catch (Exception exp)
                {
                    MessageBox.Show(exp.Message);
                }

                MessageBox.Show("Data stored to file");
            }
            else
            {
                lagreSomToolStripMenuItem_Click(true, null);
            }
               
            }
        
        //save as
        private void lagreSomToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveFileDialog1 = new SaveFileDialog();
            string date = System.DateTime.Now.ToLongDateString();
            string time = System.DateTime.Now.ToShortTimeString();

            saveFileDialog1.Filter = "txt files (*.txt)|*.txt";
            saveFileDialog1.FilterIndex = 2;
            saveFileDialog1.RestoreDirectory = true;
            saveFileDialog1.InitialDirectory = "c:\\";
            saveFileDialog1.AddExtension = true;

            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {

                // If the file name is not an empty string open it for saving.
                if (saveFileDialog1.FileName != "")
                {
                    try
                    {
                        //System.IO.FileStream fs = (System.IO.FileStream)saveFileDialog1.OpenFile();
                        StreamWriter objWriter = new StreamWriter(saveFileDialog1.OpenFile());
                        objWriter.WriteLine(date);
                        objWriter.WriteLine(time);

                        objWriter.WriteLine("");
                        objWriter.WriteLine("*******Materialdata******");
                        objWriter.WriteLine("Glass tetthet: " + mat.gDens);
                        objWriter.WriteLine("Glass E-Modul: " + mat.gEMod);
                        objWriter.WriteLine("Glass Poissons tall: " + mat.gPoi);
                        objWriter.WriteLine("Glass tapsfaktor: " + mat.gLoss);
                        objWriter.WriteLine("Luft tetthet: " + mat.aDen);
                        objWriter.WriteLine("Luft hastighet: " + mat.aSpeed);

                        objWriter.WriteLine("");

                        objWriter.WriteLine("*******Vegg data******");

                        for (int i = 0; i < wallData.wallData.Length; i++)
                        {
                            objWriter.WriteLine(freqband[i].ToString() + ": " +
                                wallData.wallData[i].ToString());
                        }

                        objWriter.WriteLine("");

                        objWriter.WriteLine("*******Vindu data******");

                        for (int i = 0; i < windowData.windowData.Length; i++)
                        {
                            objWriter.WriteLine(freqband[i].ToString() + ": " +
                                windowData.windowData[i].ToString());
                        }
                        
                        objWriter.WriteLine("");

                        objWriter.WriteLine("*******Etterklangstid data******");

                        for (int i = 0; i < revData.revData.Length; i++)
                        {
                            objWriter.WriteLine(freqband[i].ToString() + ": " +
                                revData.revData[i].ToString());
                        }
                        objWriter.WriteLine("");

                        objWriter.WriteLine("*******Utendrsspetrum******");

                        for (int i = 0; i < this.outData.outdoorData.Length; i++)
                        {
                            objWriter.WriteLine(freqband[i].ToString() + ": " +
                                outData.outdoorData[i].ToString());
                        }
                        objWriter.WriteLine("");

                        objWriter.WriteLine("*******Rom dimensjoner******");
                        objWriter.WriteLine("*******Rom volum****************");
                        objWriter.WriteLine(this.textBoxRoomVolume.Text.ToString());
                        objWriter.WriteLine("*******Skille areal****************");
                        objWriter.WriteLine(this.textBoxFacadeArea.Text.ToString());
                        objWriter.WriteLine("*******Vindu sidekant 1****************");
                        objWriter.WriteLine(this.textBoxWinDimA.Text.ToString());
                        objWriter.WriteLine("*******Vindu sidekant 2****************");
                        objWriter.WriteLine(this.textBoxWinDimB.Text.ToString());
                        objWriter.WriteLine("*******Vegg areal****************");
                        objWriter.WriteLine(this.textBoxAreaWall.Text.ToString());

                        objWriter.Close();
                    }
                    catch (Exception exp)
                    {
                        MessageBox.Show(exp.Message);
                    }
                }
                MessageBox.Show("Data er lagret");
            }
        }
   
        //open
        private void pneToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Stream myStream = null;
            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            openFileDialog1.InitialDirectory = "c:\\";
            openFileDialog1.Filter = "txt files (*.txt)|*.txt";
            openFileDialog1.FilterIndex = 2;
            openFileDialog1.RestoreDirectory = true;

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                //checkBoxWallDef.Checked = true;
                //checkBoxWindowDef.Checked = true;
                try
                {
                    if ((myStream = openFileDialog1.OpenFile()) != null)
                    {
                        //System.IO.FileStream fs = (System.IO.FileStream)saveFileDialog1.OpenFile();
                        StreamReader objReader = new StreamReader(openFileDialog1.OpenFile());
                        objReader.ReadLine();
                        objReader.ReadLine();

                        objReader.ReadLine();
                        objReader.ReadLine();

                        string tempString = objReader.ReadLine();
                        int tempInt = tempString.IndexOf(':') + 2;
                        mat.gDens = Convert.ToDouble(tempString.Substring(tempInt));

                        tempString = objReader.ReadLine();
                        tempInt = tempString.IndexOf(':') + 2;
                        mat.gEMod = Convert.ToDouble(tempString.Substring(tempInt));

                        tempString = objReader.ReadLine();
                        tempInt = tempString.IndexOf(':') + 2;
                        mat.gPoi = Convert.ToDouble(tempString.Substring(tempInt));

                        tempString = objReader.ReadLine();
                        tempInt = tempString.IndexOf(':') + 2;
                        mat.gLoss = Convert.ToDouble(tempString.Substring(tempInt));

                        tempString = objReader.ReadLine();
                        tempInt = tempString.IndexOf(':') + 2;
                        mat.aDen = Convert.ToDouble(tempString.Substring(tempInt));

                        tempString = objReader.ReadLine();
                        tempInt = tempString.IndexOf(':') + 2;
                        mat.aSpeed = Convert.ToDouble(tempString.Substring(tempInt));

                        objReader.ReadLine();
                        objReader.ReadLine();

                        for (int i = 0; i < wallData.wallData.Length; i++)
                        {
                            tempString = objReader.ReadLine();
                            tempInt = tempString.IndexOf(':') + 2;
                            wallData.wallData[i] = Convert.ToDouble(tempString.Substring(tempInt));
                        }

                        objReader.ReadLine();
                        objReader.ReadLine();

                        for (int i = 0; i < windowData.windowData.Length; i++)
                        {
                            tempString = objReader.ReadLine();
                            tempInt = tempString.IndexOf(':') + 2;
                            windowData.windowData[i] = Convert.ToDouble(tempString.Substring(tempInt));
                        }

                        objReader.ReadLine();
                        objReader.ReadLine();

                        for (int i = 0; i < revData.revData.Length; i++)
                        {
                            tempString = objReader.ReadLine();
                            tempInt = tempString.IndexOf(':') + 2;
                            revData.revData[i] = Convert.ToDouble(tempString.Substring(tempInt));
                        }

                        objReader.ReadLine();
                        objReader.ReadLine();

                        for (int i = 0; i < this.outData.outdoorData.Length; i++)
                        {
                            tempString = objReader.ReadLine();
                            tempInt = tempString.IndexOf(':') + 2;
                            outData.outdoorData[i] = Convert.ToDouble(tempString.Substring(tempInt));
                        }

                        objReader.ReadLine();
                        objReader.ReadLine();
                        objReader.ReadLine();
                        this.roomVolume = Convert.ToDouble(objReader.ReadLine());
                        objReader.ReadLine();
                        this.partitionArea = Convert.ToDouble(objReader.ReadLine());
                        objReader.ReadLine();
                        this.textBoxWinDimA.Text = objReader.ReadLine();
                        objReader.ReadLine();
                        this.textBoxWinDimB.Text = objReader.ReadLine();
                        objReader.ReadLine();
                        this.textBoxAreaWall.Text = objReader.ReadLine();

                        this.textBoxRoomVolume.Text = roomVolume.ToString();
                        this.textBoxFacadeArea.Text = partitionArea.ToString();
                        this.textBoxAreaWindow.Refresh();
                        
                        objReader.Close();
                    }

                    radioButtonModelFacade.Checked = true; // CheckedChanged(true, null);
                    MessageBox.Show("Data er hentet fra fil");

                }
                catch (System.ArgumentOutOfRangeException)
                {
                    MessageBox.Show("Error: Could not read file from disk. Wrong format");
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error: Could not read file from disk. Original error: " + ex.Message);
                }
            }
        }

        //Print
        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (facadeAvg == null)
            {
                MessageBox.Show("No insultaion data available");
            }

            else
            {
                saveFileDialog1 = new SaveFileDialog();
                string date = System.DateTime.Now.ToLongDateString();
                string time = System.DateTime.Now.ToShortTimeString();

                saveFileDialog1.Filter = "txt files (*.txt)|*.txt";
                saveFileDialog1.FilterIndex = 2;
                saveFileDialog1.RestoreDirectory = true;
                saveFileDialog1.InitialDirectory = "c:\\";
                saveFileDialog1.AddExtension = true;

                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {

                    // If the file name is not an empty string open it for saving.
                    if (saveFileDialog1.FileName != "")
                    {
                        try
                        {
                            //System.IO.FileStream fs = (System.IO.FileStream)saveFileDialog1.OpenFile();
                            StreamWriter objWriter = new StreamWriter(saveFileDialog1.OpenFile());
                            objWriter.WriteLine(date);
                            objWriter.WriteLine(time);

                            objWriter.WriteLine("");
                            objWriter.WriteLine("*******Materialdata******");
                            objWriter.WriteLine("Glass tetthet: " + mat.gDens);
                            objWriter.WriteLine("Glass E-Modul: " + mat.gEMod);
                            objWriter.WriteLine("Glass Poissons tall: " + mat.gPoi);
                            objWriter.WriteLine("Glass tapsfaktor: " + mat.gLoss);
                            objWriter.WriteLine("Luft tetthet: " + mat.aDen);
                            objWriter.WriteLine("Luft hastighet: " + mat.aSpeed);

                            objWriter.WriteLine("");

                            objWriter.WriteLine("*******Isolasjonsdata******");

                            objWriter.WriteLine("");

                            if (graph.getStat() == null)
                            {
                            }
                            else
                            {
                                double[] returns = graph.getStat();
                                if (returns[8] == 1) // 1 = Dw
                                {
                                    objWriter.WriteLine("Dw(C;Ctr;C_(50-5000);C_tr(50-5000)) = Dw(" + returns[0].ToString() +
                                      ";" + returns[3].ToString() + ";" + returns[4].ToString() + ";" + returns[5].ToString() +
                                      ";" + returns[6].ToString() + ") dB");
                                    objWriter.WriteLine("Sum negative avvik: " + returns[1].ToString() + "dB");
                                    objWriter.WriteLine("Max negative avvik: " + returns[2].ToString() + "dB, ved: " +
                                        returns[7].ToString() + " Hz");
                                }
                            }

                            objWriter.WriteLine("");

                            for (int i = 0; i < this.facadeAvg.Length; i++)
                            {
                                objWriter.WriteLine(freqband[i].ToString() + " Hz: " + facadeAvg[i].ToString() + " dB");
                            }

                            objWriter.WriteLine("");

                            objWriter.WriteLine("*******Isolasjonsdata til kopi******");

                            for (int i = 0; i < this.facadeAvg.Length; i++)
                            {
                                objWriter.WriteLine(facadeAvg[i].ToString());
                            }


                            objWriter.Close();
                        }
                        catch (Exception exp)
                        {
                            MessageBox.Show(exp.Message);
                        }
                    }
                    MessageBox.Show("Data er lagret");
                }
            }
        }
        


        #endregion

        #region Connects and calculates the insulation data
        private double[] connectAndGetFromModel()
        {
            Console.WriteLine("getting data from model");

            double wallArea = 0.00;
            //double ventilationArea = 0.00;
            double windowArea = 0.00;

            try
            {
                wallArea = Convert.ToDouble(this.textBoxAreaWall.Text);
                windowArea = Convert.ToDouble(this.textBoxAreaWindow.Text);
            }
            catch (FormatException exp)
            {
                MessageBox.Show("Non-valid input data" + exp.Message, "Exception occured");
            }

            facadeAvg = new double[21];
            double[] wall = new double[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            double[] window = new double[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            int wallRw = 0;

            //checks if walldata is predefined!
            if (this.checkBoxWallDef.Checked == true)
            {
                wall = this.wallData.getWallData();
                Console.WriteLine("Getting from definition data");
            }
            else
            {
                //Getting wall data
                if (this.comboBoxWallMaterial.Text == "Wood, light")
                {
                    //Data hentet fra datasamlingen "Lydisolerende konstruksjoner", yttervegg med 
                    //og Canadiske labdata "Laboratory measurements". Tilsvarer vel omtrent konstruksjonsnr 229 i H47 med Rw(C;Ctr) = 46(-1;-3)
                    wall = new double[] { 20.65, 20.89, 23.4, 24, 25, 36, 33, 40, 42, 42, 44, 45, 46, 49, 51, 54, 53, 53, 56, 56, 56 };
                    wallRw = 47; //adjustable factor
                }
                else if (this.comboBoxWallMaterial.Text == "Wood, heavy")
                {
                    //Bastian data: SBUF YV-I: 19 panel, 150 timmervegg, 22 innerpanel SAU beregninger. Korrigert mot empiriske data
                    wall = new double[] { 16.9, 17.9, 19.2, 14.4, 16.4, 18.5, 20.3, 22.1, 23.8, 25.1, 26.8, 27.3, 24.3, 24.0, 27.1, 30.4, 33.4, 36.3, 39.3, 42.4, 45.3 };
                    wallRw = 32;
                }
                else if (this.comboBoxWallMaterial.Text == "Masonry/concrete")
                {
                    //Data hentet fra datasamlingen "Lydisolerende konstruksjoner", Gruppe 9,d Enkle massive vegger i tegl 
                    //og Canadiske labdata "Laboratory measurements" & Bastian og beregninger
                    wall = new double[] { 30, 32, 34, 38, 43, 42, 44, 44, 47, 49, 53, 54, 56, 60, 62, 63, 66, 66, 67, 70, 72 };
                    wallRw = 56;
                }
                else
                {
                    MessageBox.Show("No valid wall data");
                    wall = new double[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
                }
                //Corrects the wall insulation data according to the Rw 
                for (int i = 0; i < wall.Length; i++)
                {
                    wall[i] = wall[i] + (Convert.ToDouble(this.comboBoxRwCtrWallMAterial.Text)
                        - wallRw);
                }
            }

            //Getting insulation data
            if (this.comboBoxInsulation.Text == "Mineral wool")
            {
                for (int i = 0; i < wall.Length; i++)
                {
                    wall[i] = wall[i];
                }
            }
            else if (this.comboBoxInsulation.Text == "Unknown or none")
            {
                //do nothing
            }
            else
            {
                MessageBox.Show("No valid insulation data");
                //do nothing
            }

            //Getting ventilation data
            if (this.comboBoxVentilation.Text == "None")
            {
                for (int i = 0; i < wall.Length; i++)
                {
                    wall[i] = wall[i];
                }
            }
            else if (this.comboBoxVentilation.Text == "Slit in window")
            {
                for (int i = 0; i < wall.Length; i++)
                {
                    wall[i] = wall[i] + 3;
                }
            }
            else if (this.comboBoxVentilation.Text == "Hole in wall")
            {
                for (int i = 0; i < wall.Length; i++)
                {
                    wall[i] = wall[i] + 3;
                }
            }
            else
            {
                MessageBox.Show("No valid ventilation data");
                for (int i = 0; i < wall.Length; i++)
                {
                    wall[i] = wall[i];
                }
            }

            //Calculates the window insulation data

            //Checks if window data is predefined:
            if (this.checkBoxWindowDef.Checked == true)
            {
                window = this.windowData.getWindowData();
            }
            else
            {

                double gDens = mat.gDens;
                double gEMod = mat.gEMod;
                double gPoi = mat.gPoi;
                double gLoss = mat.gLoss;
                double aDen = mat.aDen;
                double aSpeed = mat.aSpeed;

                #region calculates for single panel
                if (this.comboBoxWindowType.Text == "Single glazing")
                {
                    Console.WriteLine("getting data from model: single glazing");
                    
                    double ma = 0;
                    double mb = 0;
                    double h1 = 0;
                

                    double fc1 = 0;
                    fc1n = 0;
                    
                    try
                    {
                        ma = Convert.ToDouble(this.textBoxWinDimA.Text); //thickness of pane
                        mb = Convert.ToDouble(this.textBoxWinDimB.Text); //thickness of pane  
                        h1 = Convert.ToDouble(this.textBox1glasssthickness.Text) * 0.001; //thickness of pane
                    
                        this.textBoxAreaWindow.Text = (ma * mb).ToString();
                    }
                    catch (System.FormatException exp)
                    {
                        MessageBox.Show(exp.Message);
                    }
                    double massunit = gDens * h1;

                    //calculating the critical frequency fc1 and fc2
                    //fc = (c^2./ (1.81*h))*sqrt((d*(1-p^2)) / E)
                    fc1 = (Math.Pow(mat.aSpeed, 2) / (1.81 * h1))
                        * Math.Sqrt((mat.gDens * (1 - Math.Pow(mat.gPoi, 2))) / (mat.gEMod));

                    //calculating the critical frequency fc1 and fc2
                    //fnm = pi/2 * sqrt((E*h^2) / ((12*dg) * (1-p^2))) * ((1/ma)^2 + (1/mb)^2 )
                    double fnm = Math.PI / 2 * Math.Sqrt((mat.gEMod * Math.Pow(h1, 2)) /
                        ((12 * mat.gDens) * (1 - Math.Pow(mat.gPoi, 2)))) *
                        (Math.Pow((1 / ma), 2) + (Math.Pow((1 / mb), 2)));
                    Console.WriteLine("getting data from model: single glazing: Critical frequency: " + fc1.ToString() +
                        " first panel resonance: " + fnm.ToString());
                    //calculating the transmission loss
                    
                    double delta = 0;
                    double deltaf = 0;
                    double[] S = new double[21];
                    double[] P = new double[21];

                    for (int n = 0; n < window.Length; n++)
                    {
                        delta = 0.23156;
                        deltaf = delta * freqband[n] / 2;
                        //finds the frequency band with the critical frecuency:
                        
                        Console.WriteLine("Finding the critical frequency @ "+n.ToString() + delta.ToString() + " and deltaf" + deltaf.ToString());
                        if ((fc1 > (freqband[n] - deltaf)) && (fc1 < (freqband[n] + deltaf)))
                        {
                            fc1n = n+1;
                            Console.WriteLine("Found the critical frequency @ " + fc1n.ToString());
                        }
                    }

                    //Calculating the sound reduction index
                    for (int n = 0; n < window.Length; n++)
                    {
                       S[n] = 20 * Math.Log10((Math.PI * freqband[n] * massunit) / (aDen * aSpeed)) - 5.5;
                        P[n] = 20 * Math.Log10((Math.PI * freqband[n] * massunit) / (aDen * aSpeed)) + 
                            10 * Math.Log10((2 * gLoss * freqband[n]) / (Math.PI * fc1)) - 5.5;
                    }

                    int n1 = 1;
                    int n2 = 1;
                    
                    for (int n = 0; n < window.Length; n++)
                    {

                        if (freqband[n] < fnm)                       // stivhetsstyrt
                        {
                            window[n] = -20 * Math.Log10((Math.PI * freqband[n] * massunit) / (aDen * aSpeed)) +
                                20 * Math.Log10((Math.PI * fnm * massunit) / (aDen * aSpeed)) - 5.5; //stiffness area
                        }
                        else if (freqband[n] < fc1 / 2)           //    % masseloven
                        {
                            window[n] = 20 * Math.Log10((Math.PI * freqband[n] * massunit) / (aDen * aSpeed)) - 5.5; //%-5 fra bies og hansen 80 graders in-situ innfalssvinkel 
                            n1 = n;
                        }
                        else if (freqband[n] > fc1)
                        {
                            window[n] = 20 * Math.Log10((Math.PI * freqband[n] * massunit) / (aDen * aSpeed)) +
                                10 * Math.Log10((2 * gLoss * freqband[n]) / (Math.PI * fc1)) - 5.5; // -5 for 80 graders innfallsevinkel som i bies og hansen i felt
                             if ((n > 1) && (freqband[n-1] < fc1))
                            {
                                n2 = n;
                            }
                        }
                        else //(freqband[n] > fc )      //   % over grensefrekvensen
                        {
                           // window[n] = 32;
                        }
                       
                    }

                    double AA = 20.0 / (freqband[n1]*Math.Log(10));
                    double BB = 20.0 / (freqband[n2]*Math.Log(10)) + 
                        10.0 / (Math.Log(10)*freqband[n2]);

                    double[] interp = interpol(freqband[n1],S[n1],freqband[n2],P[n2],AA,BB);
                    for (int n = 0; n < window.Length; n++)
                    {    
                        if ((freqband[n] > fc1/2) && (freqband[n] < fc1))        
                        {
                            window[n] = interp[0]*Math.Pow((freqband[n]),3) + interp[1]*Math.Pow(freqband[n],2) + 
                                interp[2]*(freqband[n]) +interp[3];
                        }
                    }

                    // for debugging
                    // window = new double[] { 23, 23, 23, 23, 24, 27, 17, 21, 35, 41, 44, 45, 45, 47, 46, 46, 45, 42, 35, 35, 35 };

                }
                #endregion
    
                #region calculates for double panel
                else if (this.comboBoxWindowType.Text == "Double glazing")
                {
                    Console.WriteLine("getting data from model: double glazing");
                    double fc1 = 0;
                    double fc2 = 0;
                    double fd = 0;
                    double ma = 0;
                    double mb = 0;
                    double[] S = new double[21];
                    double[] P = new double[21];

                    /**
                    Console.WriteLine(" Den: " + this.mat.gDens.ToString() + " E-mod: " +
                       this.mat.gEMod.ToString() + " Poi: " +
                       this.mat.gPoi.ToString() + " Loss: " +
                       this.mat.gLoss.ToString() + " aDen: " +
                       this.mat.aDen.ToString() + " aSpeed: " +
                       this.mat.aSpeed.ToString() + " ");
                     * */


                    try
                    {
                        double h1 = Convert.ToDouble(this.textBox1glasssthickness.Text) * 0.001; //thickness of pane
                        double h2 = Convert.ToDouble(this.textBox2glassthickness.Text) * 0.001; //thickness of pane
                        double massunit1 = h1 * gDens;
                        double massunit2 = h2 * gDens;
                        ma = Convert.ToDouble(this.textBoxWinDimA.Text); //thickness of pane
                        mb = Convert.ToDouble(this.textBoxWinDimB.Text); //thickne

                        //calculating the critical frequency fc1 and fc2
                        //fc = (c^2./ (1.81*h))*sqrt((d*(1-p^2)) / E)
                        fc1 = (Math.Pow(mat.aSpeed, 2) / (1.81 * h1))
                            * Math.Sqrt((mat.gDens * (1 - Math.Pow(mat.gPoi, 2))) / (mat.gEMod));
                        fc2 = (Math.Pow(mat.aSpeed, 2) / (1.81 * h2))
                            * Math.Sqrt((mat.gDens * (1 - Math.Pow(mat.gPoi, 2))) / (mat.gEMod));
                        Console.WriteLine("getting data from model: double glazing: Critical frequency: " + fc1.ToString());

                        //calculating mass-spring-mass resonance
                        //fd = 60* sqrt((m1+m2)./(m1*m2*s))
                        double m1 = h1 * mat.gDens;   //surface mass
                        double m2 = h2 * mat.gDens;   //surface mass
                        double s = Convert.ToDouble(this.textBox1interpanespace.Text) * 0.001;
                        fd = 60 * Math.Sqrt((m1 + m2) / (m1 * m2 * s));
                        Console.WriteLine("getting data from model: double glazing: mass-spring-mass: " + fd.ToString());
                        // til debugging window = new double[] { 23, 23, 23, 23, 24, 27, 17, 21, 35, 41, 44, 45, 45, 47, 46, 46, 45, 42, 35, 35, 35 };


                        double delta = 0;
                        double deltaf = 0;

                         for (int n = 0; n < window.Length; n++)
                        {
                            delta = 0.23156;
                            deltaf = delta * freqband[n] / 2;
                            //finds the frequency band with mass-air-mass resonance:

                            Console.WriteLine("Finding the resonannce @ " + n.ToString() + delta.ToString() + " and deltaf" + deltaf.ToString());
                            if ((fd > (freqband[n] - deltaf)) && (fd < (freqband[n] + deltaf)))
                            {
                                fdn = n + 1;
                                Console.WriteLine("Found the resonance @ " + fdn.ToString());
                            }
                        
                        
                            //finds the frequency band with the critical frecuencies:

                            Console.WriteLine("Finding the critical frequency @ " + n.ToString() + delta.ToString() + " and deltaf" + deltaf.ToString());
                            if ((fc1 > (freqband[n] - deltaf)) && (fc1 < (freqband[n] + deltaf)))
                            {
                                fc1n = n + 1;
                                Console.WriteLine("Found the critical frequency @ " + fc1n.ToString());
                            }

                            if ((fc2 > (freqband[n] - deltaf)) && (fc2 < (freqband[n] + deltaf)))
                            {
                                fc2n = n + 1;
                                Console.WriteLine("Found the critical frequency @ " + fc1n.ToString());
                            }
                        }
                            
                        //Calculates the sound reduction index

                        double[] R1 = predsingle(massunit1, h1, ma, mb, gLoss, freqband);
                        double[] R2 = predsingle(massunit2, h2, ma, mb, gLoss, freqband);
                        int n1 = 1;
                        int n2 = 1;

                        for (int n = 0; n < window.Length; n++)
                        {

                            if (freqband[n] < 2*fd/3)                       // stivhetsstyrt
                            {
                                window[n] = 20 * Math.Log10((Math.PI * freqband[n] *( massunit1 + massunit2)) / (aDen * aSpeed)) - 5.5; //stiffness area
                                n1 = n;
                            }
                            else if (freqband[n] < fc1 )           //    % masseloven
                            {
                                window[n] = R1[n] + R2[n] - 29;
                                if ((n > 1) && (freqband[n - 1] < fd))
                                {
                                    n2 = n;
                                }
                            }
                            else if (freqband[n] > fc1)
                            {
                                window[n] = R1[n] + R2[n] - 29;
                            }
                            else //(freqband[n] > fc )      //   % over grensefrekvensen
                            {
                               // window[n] = 32;
                            }

                        }

                        double AA = 20.0 / (freqband[n1] * Math.Log(10));
                        double BB = 2 * 20.0 / (freqband[n2] * Math.Log(10));

                        for (int n = 0; n < window.Length; n++)
                        {
                            S[n] = 20 * Math.Log10((Math.PI * freqband[n] * (massunit1+massunit2)) / (aDen * aSpeed)) - 5.5;
                            P[n] = R1[n] + R2[n] -29;
                        }

                        double[] interp = interpol(freqband[n1], S[n1], freqband[n2], P[n2], AA, BB);
                        for (int n = 0; n < window.Length; n++)
                        {
                            if ((freqband[n] > 2*fd / 3) && (freqband[n] < fd))
                            {
                                window[n] = interp[0] * Math.Pow((freqband[n]), 3) + interp[1] * Math.Pow(freqband[n], 2) +
                                    interp[2] * (freqband[n]) + interp[3];
                            }
                        }


                        }
                        
                        catch (FormatException exp)
                    {
                        MessageBox.Show(exp.Message);
                    }
                }

                #endregion 

                else if (this.comboBoxWindowType.Text == "Triple glazing")
                {
                    MessageBox.Show("Sorry, No triple windows implemented yet");
                }
                else
                {
                    MessageBox.Show("No valid window data");
                }


            }

            //Calculatig the logarithmical sum of all elements
            for (int i = 0; i < wall.Length; i++)
            {
                facadeAvg[i] = 10 * Math.Log10(
                ((wallArea + windowArea) /
                (wallArea * Math.Pow(10, (-wall[i] / 10)) +
                (windowArea * Math.Pow(10, (-window[i] / 10))))));
                Console.WriteLine("Writing from model calculations: i: " + i.ToString() + " = " + facadeAvg[i]);
            }

            //double[] ISO717example = new double[] { 18.7, 19.2, 20.2, 20.4, 16.3, 17.7, 22.6, 22.4, 22.7, 24.8, 26.6, 28, 30.5, 31.8, 32.5, 33.4, 33, 31, 25.5, 26.8, 29.2 };    
            //double[] ISO717example = new double[] { 39.5, 36.1, 36.4, 34.6, 35.7, 40.0, 42.6, 43.6, 45.6, 53.9, 56.9, 62.6, 65.6, 68.9, 71.9, 73.3, 76.9, 77, 78.7, 81.7, 76.1 };    
            //facadeAvg = ISO717example;
            facadeString = null;
            return facadeAvg;
        }
        #endregion

        #region method for calculating of single panel
        private double[] predsingle(double massunit, double h1, double ma, double mb, double nloss, double[] f)
        {
            double gDens = mat.gDens;
            double gEMod = mat.gEMod;
            double gPoi = mat.gPoi;
            double gLoss = mat.gLoss;
            double aDen = mat.aDen;
            double aSpeed = mat.aSpeed;

            double[] window = new double[21];
                    //calculating the critical frequency fc1 and fc2
                    //fc = (c^2./ (1.81*h))*sqrt((d*(1-p^2)) / E)
                    double fc1 = (Math.Pow(mat.aSpeed, 2) / (1.81 * h1))
                        * Math.Sqrt((mat.gDens * (1 - Math.Pow(mat.gPoi, 2))) / (mat.gEMod));

                    //calculating the critical frequency fc1 and fc2
                    //fnm = pi/2 * sqrt((E*h^2) / ((12*dg) * (1-p^2))) * ((1/ma)^2 + (1/mb)^2 )
                    double fnm = Math.PI / 2 * Math.Sqrt((mat.gEMod * Math.Pow(h1, 2)) /
                        ((12 * mat.gDens) * (1 - Math.Pow(mat.gPoi, 2)))) *
                        (Math.Pow((1 / ma), 2) + (Math.Pow((1 / mb), 2)));
                    Console.WriteLine("getting data from model: single glazing: Critical frequency: " + fc1.ToString() +
                        " first panel resonance: " + fnm.ToString());
                    //calculating the transmission loss
                    
                 
                    double[] S = new double[21];
                    double[] P = new double[21];

                    //Calculating the sound reduction index
                    for (int n = 0; n < window.Length; n++)
                    {
                        S[n] = 20 * Math.Log10((Math.PI * freqband[n] * massunit) / (aDen * aSpeed)) - 5.5;
                        P[n] = 20 * Math.Log10((Math.PI * freqband[n] * massunit) / (aDen * aSpeed)) + 
                        10 * Math.Log10((2 * gLoss * freqband[n]) / (Math.PI * fc1)) - 5.5;
                    }

                    int n1 = 1;
                    int n2 = 1;
                    
                    for (int n = 0; n < window.Length; n++)
                    {

                        if (freqband[n] < fnm)                       // stivhetsstyrt
                        {
                            window[n] = -20 * Math.Log10((Math.PI * freqband[n] * massunit) / (aDen * aSpeed)) +
                                20 * Math.Log10((Math.PI * fnm * massunit) / (aDen * aSpeed)) - 5.5; //stiffness area
                        }
                        else if (freqband[n] < fc1 / 2)           //    % masseloven
                        {
                            window[n] = 20 * Math.Log10((Math.PI * freqband[n] * massunit) / (aDen * aSpeed)) - 5.5; //%-5 fra bies og hansen 80 graders in-situ innfalssvinkel 
                            n1 = n;
                        }
                        else if (freqband[n] > fc1)
                        {
                            window[n] = 20 * Math.Log10((Math.PI * freqband[n] * massunit) / (aDen * aSpeed)) +
                                10 * Math.Log10((2 * gLoss * freqband[n]) / (Math.PI * fc1)) - 5.5; // -5 for 80 graders innfallsevinkel som i bies og hansen i felt
                             if ((n > 1) && (freqband[n-1] < fc1))
                            {
                                n2 = n;
                            }
                        }
                        else //(freqband[n] > fc )      //   % over grensefrekvensen
                        {
                           // window[n] = 32;
                        }
                       
                    }

                    double AA = 20.0 / (freqband[n1]*Math.Log(10));
                    double BB = 20.0 / (freqband[n2]*Math.Log(10)) + 
                        10.0 / (Math.Log(10)*freqband[n2]);

                    double[] interp = interpol(freqband[n1],S[n1],freqband[n2],P[n2],AA,BB);
                    for (int n = 0; n < window.Length; n++)
                    {    
                        if ((freqband[n] > fc1/2) && (freqband[n] < fc1))        
                        {
                            window[n] = interp[0]*Math.Pow((freqband[n]),3) + interp[1]*Math.Pow(freqband[n],2) + 
                                interp[2]*(freqband[n]) +interp[3];
                        }
                    }

                    // for debugging
                    // window = new double[] { 23, 23, 23, 23, 24, 27, 17, 21, 35, 41, 44, 45, 45, 47, 46, 46, 45, 42, 35, 35, 35 };

                

            return window;
        }
        #endregion

        #region interpolates between values
        private double[] interpol(double xx1, double yy1, double xx2, double yy2, double mm, double nn)
        {

            double[] arrC = new double[4];

            double[][] arrA = new double[][] {new double[] {Math.Pow(xx1,3), Math.Pow(xx1,2), xx1, 1}, 
                        new double[]{Math.Pow(xx2,3), Math.Pow(xx2,2), xx2, 1}, 
                        new double[]{3*Math.Pow(xx1,2), 2*Math.Pow(xx1,1), 1, 0}, 
                        new double[]{3*Math.Pow(xx2,2), 2*Math.Pow(xx2,1), 1, 0}};

            Matrix matrixA = new Matrix(arrA);

            double[][] arrB ={ new double[] { yy1 }, new double[] { yy2 }, new double[] { mm }, new double[] { nn } };
            Matrix matrixB = new Matrix(arrB);  //(new Matrix(1, 4);

            Matrix matrixAinverse = matrixA.Inverse;

            Matrix matC = Matrix.Multiply(matrixAinverse, matrixB);

            arrC[0] = matC[0, 0];
            arrC[1] = matC[1, 0];
            arrC[2] = matC[2, 0];
            arrC[3] = matC[3, 0];
            return arrC;
        }
        #endregion

        #region calculates the inverse a-weigted level
        public double[] doInverseAweight(double[] spc)
        {
            double[] temp = new double[spc.Length];
            double[] aweight = new double[] {30.2, 26.2, 22.5,
                19.1, 16.1, 13.4, 10.9, 8.6, 6.6, 4.8, 3.2, 1.9, 0.8,
                0.0, -0.6, -1.0, -1.2, -1.3, -1.2, -1.0, -0.5, 0.1, 1.1, 2.5, 4.3, 6.6, 9.3 };

            for (int i = 0; i < spc.Length; i++)
            {
                temp[i] = spc[i] + aweight[i];
                //Console.WriteLine("writing the spc:" + spc[i]);
            }
            return temp;
        }
        #endregion

        #region Connects and returns the standard spectrum
        private double[] connectAndGetFromStdSpectrum()
        {
            trafficAvg = null;
            Console.WriteLine("getting data from standardSpectrum");
            try
            {

               
               

                    int leqOut = Convert.ToInt32(this.textBoxOutdoorLevel.Text);

                    double[] c1 = new double[] { -29 + leqOut, -24+ leqOut, -23+ leqOut, -23+ leqOut, -22+ leqOut, -20+ leqOut,
                -17+ leqOut, -15+ leqOut, -16+ leqOut, -15+ leqOut, -13+ leqOut, -11+ leqOut, -10+ leqOut, -8+ leqOut,
                -7+ leqOut, -9+ leqOut, -11+ leqOut, -14+ leqOut, -17+ leqOut, -20+ leqOut, -24+ leqOut };
                    double[] c2 = new double[] { -25+ leqOut, -23+ leqOut, -21+ leqOut, -20+ leqOut, -20+ leqOut, -18+ leqOut,
                -16+ leqOut, -15+ leqOut, -14+ leqOut, -13+ leqOut, -12+ leqOut, -11+ leqOut, -9+ leqOut, -8+ leqOut,
                -9+ leqOut, -10+ leqOut, -11+ leqOut, -13+ leqOut, -15+ leqOut, -16+ leqOut, -18+ leqOut };
                    double[] c3 = new double[] { -44+ leqOut, -37+ leqOut, -28+ leqOut, -27+ leqOut, -25+ leqOut, -25+ leqOut,
                -22+ leqOut, -18+ leqOut, -16+ leqOut, -15+ leqOut, -12+ leqOut, -9+ leqOut, -7+ leqOut, -7+ leqOut, 
                -9+ leqOut, -10+ leqOut, -13+ leqOut, -15+ leqOut, -17+ leqOut, -20+ leqOut, -21+ leqOut };
                    double[] c4 = new double[] { -21+ leqOut, -17+ leqOut, -16+ leqOut, -17+ leqOut, -17+ leqOut, -15+ leqOut,
                -13+ leqOut, -11+ leqOut, -13+ leqOut, -13+ leqOut, -12+ leqOut, -11+ leqOut, -11+ leqOut, -9+ leqOut, 
                -9+ leqOut, -12+ leqOut, -15+ leqOut, -19+ leqOut, -23+ leqOut, -27+ leqOut, -32+ leqOut };
                    double[] c5 = new double[] { -17+ leqOut, -16+ leqOut, -14+ leqOut, -14+ leqOut, -15+ leqOut, -13+ leqOut,
                -12+ leqOut, -11+ leqOut, -11+ leqOut, -11+ leqOut, -11+ leqOut, -11+ leqOut, -10+ leqOut, -9+ leqOut,
                -11+ leqOut, -13+ leqOut, -15+ leqOut, -18+ leqOut, -21+ leqOut, -23+ leqOut, -26+ leqOut };
                    double[] c6 = new double[] { -35+ leqOut, -29+ leqOut, -20+ leqOut, -20+ leqOut, -19+ leqOut, -19+ leqOut,
                -17+ leqOut, -13+ leqOut, -12+ leqOut, -12+ leqOut, -10+ leqOut, -8+ leqOut, -7+ leqOut, -7+ leqOut, 
                -10+ leqOut, -12+ leqOut, -16+ leqOut, -19+ leqOut, -22+ leqOut, -26+ leqOut, -28+ leqOut };


                    if (this.comboBoxStdSpectrum.Text.Equals("C1, City 30 km/t"))
                    {
                        trafficString = "C1, City 30 km/t";
                        //c1 = doAweight(c1);
                        return c1;
                    }
                    else if (this.comboBoxStdSpectrum.Text.Equals("C2, City 50 km/t (Ctr)"))
                    {
                        trafficString = "C2, City 50 km/t (Ctr)";
                        //c2 = doAweight(c2);
                        return c2;
                    }
                    else if (this.comboBoxStdSpectrum.Text.Equals("C3, Highway 90 km/t"))
                    {
                        trafficString = "C3, Highway 90 km/t";
                        //c3 = doAweight(c3);
                        return c3;
                    }
                    else if (this.comboBoxStdSpectrum.Text.Equals("C4, City 30 km/t (screened)"))
                    {
                        trafficString = "C4, City 30 km/t (screened)";
                        //c4 = doAweight(c4);
                        return c4;
                    }
                    else if (this.comboBoxStdSpectrum.Text.Equals("C5, City 50 km/t (screened)"))
                    {
                        trafficString = "C5, City 50 km/t (screened)";
                        //c5 = doAweight(c5);
                        return c5;
                    }
                    else if (this.comboBoxStdSpectrum.Text.Equals("C6, Highway 90 km/t (screened)"))
                    {
                        trafficString = "C6, Highway 90 km/t (screened)";
                        //c6 = doAweight(c6);
                        return c6;
                    }

                    else
                    {
                        Console.WriteLine("Errors finding the standard spectrum traffic data");
                        return null;
                    }
                
            }
            catch (System.FormatException)
            {
                MessageBox.Show("Fill inn outdoor noise level");
                return null;
            }
        }
        #endregion

        #region Connects and returns traffic data from Database
        private double[] connectAndGetTableFromDBTraffic()
        {
            Console.WriteLine("getting data from Stairway traffic");
            trafficAvg = new double[21];
            trafficStdDev = new double[21];
           
            /**
            string SQlString = "SELECT avg(Rt.[50]), avg(Rt.[63]) ,avg(Rt.[80]) ,avg(Rt.[100]),avg(Rt.[125]),avg(Rt.[160]),avg(Rt.[200]),avg(Rt.[250]),avg(Rt.[315]), avg(Rt.[40]),avg(Rt.[500]) ,avg(Rt.[630]) ,avg(Rt.[800]),avg(Rt.[1000]),avg(Rt.[1250]),avg(Rt.[1600]),avg(Rt.[2000]),avg(Rt.[2500]),avg(Rt.[3150]),avg(Rt.[4000]) ,avg(Rt.[5000])" +
                ", stdev(Rt.[50]), stdev(Rt.[63]) ,stdev(Rt.[80]) ,stdev(Rt.[100]),stdev(Rt.[125]),stdev(Rt.[160]),stdev(Rt.[200]),stdev(Rt.[250]),stdev(Rt.[315]), stdev(Rt.[40]),stdev(Rt.[500]) ,stdev(Rt.[630]) ,stdev(Rt.[800]),stdev(Rt.[1000]),stdev(Rt.[1250]),stdev(Rt.[1600]),stdev(Rt.[2000]),stdev(Rt.[2500]),stdev(Rt.[3150]),stdev(Rt.[4000]) ,stdev(Rt.[5000]), count(*), avg(Ri.[Buildings])" +
                     " FROM [StairWay].[dbo].[012 Main_road] AS Ri,[StairWay].[dbo].[112 Third_octave_Leq] AS Rt " +
                        " WHERE Ri.[Ident] = Rt.[Ident] " +
                        " AND Ri.[Speed limit] >= '" + textBoxTrSpeed.Text + "'" +
                        " AND Ri.[Speed limit] <= '" + textBoxTrSpeed2.Text + "'" +
                        " AND Ri.[Distance] >= '" + textBoxTrDistance.Text + "'" +
                        " AND Ri.[Distance] <= '" + textBoxTrDistance2.Text + "'" +
                        " AND Ri.[Critical height] >= '" + textBoxTrCritical.Text + "'" +
                        " AND Ri.[Critical height] <= '" + textBoxTrCritical2.Text + "'";

            Console.WriteLine("Writing sql query with: " + SQlString);

            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand dbcomm = new SqlCommand();
            SqlDataReader reader = null;

            try
            {
                conn.Open();
                dbcomm.CommandType = CommandType.Text;
                dbcomm.CommandText = SQlString;
                dbcomm.Connection = conn;
                reader = dbcomm.ExecuteReader();

                int columnOrdial = 0;
                reader.Read();
                while (columnOrdial < 21)
                {
                    try
                    {
                        double dec = Convert.ToDouble(reader.GetValue(columnOrdial));
                        Console.WriteLine("writes from reader, avg: " + dec);
                        this.trafficAvg[columnOrdial] = dec;
                        double db = Convert.ToDouble(reader.GetValue(21 + columnOrdial));
                        Console.WriteLine("writes from reader, stdev: " + db);
                        this.trafficStdDev[columnOrdial] = db;
                        columnOrdial++;
                    }
                    catch (System.Data.SqlTypes.SqlNullValueException)
                    {
                        MessageBox.Show("No data available");
                        return null;
                        //break;
                    }
                }

                this.numOfTr = reader.GetInt32(42);
                Console.WriteLine("writes from reader, num: " + this.numOfFa.ToString());
                this.buildings = Convert.ToDouble(reader.GetValue(43));
                Console.WriteLine("writes from reader, buildings: " + this.buildings.ToString());
          

            }
            catch (InvalidOperationException ex)
            {
                MessageBox.Show(ex.Message);
            }
            catch (SqlException ex)
            {
                MessageBox.Show(ex.Message);
            }
            if (reader != null)
            {
                reader.Close();
            }

            trafficString = SQlString;
            conn.Close();
            return this.doAweight(trafficAvg); //returns A-weighted traffic spectra
             * */
            numOfTr = 11;
            this.buildings = 3;
            trafficAvg = new double[] { 62, 66, 64, 60, 58, 56, 56, 55, 55, 59, 57, 60, 60, 61, 59, 57, 55, 52, 50, 48, 45};
            //this.trafficStdDev = new double[]{2.9, 2, 1.7, 1.3, 1.8, 1.6, 2.45, 2.9, 2.9, 3, 1.7, 1.2, 1.9, 1.9, 2.2, 1.9, 2.9, 3.4, 4.5, 5.2, 5.7};
            return this.doAweight(trafficAvg); //returns lin traffic spectra
        }
        #endregion

        #region calculates the a-weighting for an array
        public double[] doAweight(double[] spc)
        {
            double[] aweight = new double[] {-30.2, -26.2, -22.5,
                -19.1, -16.1, -13.4, -10.9, -8.6, -6.6, -4.8, -3.2, -1.9, -0.8,
                0.0, 0.6, 1.0, 1.2, 1.3, 1.2, 1.0, 0.5, -0.1, -1.1, -2.5, -4.3, -6.6, -9.3 };

            for (int i = 0; i < spc.Length; i++)
            {
                spc[i] = spc[i] + aweight[i];
                //Console.WriteLine("writing the spc:" + spc[i]);
            }
            return spc;
        }
        #endregion

        #region Connects and returns facade data from Database
        private double[] connectAndGetTableFromDBFacade()
        {
            Console.WriteLine("getting data from Stairway facade");
            facadeAvg = new double[21];
            facadeStdDev = new double[21];
            /**
            string SQlString = "SELECT stdev([50Hz]), stdev([63Hz]) ,stdev([80Hz]) ,stdev([100Hz]),stdev([125Hz]),stdev([160Hz]),stdev([200Hz]),stdev([250Hz])" +
                    " ,stdev([315Hz]), stdev([400Hz]),stdev([500Hz]) ,stdev([630Hz]) ,stdev([800Hz]),stdev([1000Hz]),stdev([1250Hz]),stdev([1600Hz]),stdev([2000Hz])" +
                    " ,stdev([2500Hz]),stdev([3150Hz]),stdev([4000Hz]) ,stdev([5000Hz]), avg([50Hz]), avg([63Hz]) ,avg([80Hz]) ,avg([100Hz]),avg([125Hz]),avg([160Hz]),avg([200Hz]),avg([250Hz])" +
                    " ,avg([315Hz]), avg([400Hz]),avg([500Hz]) ,avg([630Hz]) ,avg([800Hz]),avg([1000Hz]),avg([1250Hz]),avg([1600Hz]),avg([2000Hz])" +
                    " ,avg([2500Hz]),avg([3150Hz]),avg([4000Hz]) ,avg([5000Hz]),count(*)" +
                    " FROM [StairWay].[dbo].[063 Facade_info] AS Fi,[StairWay].[dbo].[612 Facade_insulation_third_octave] AS Ft " +
                    " WHERE Fi.Ident = Ft.Ident" +
                    " AND Fi.[Window] = '" + this.comboBoxSwWindow.SelectedItem + "'" +
                    " AND Fi.[Insulation] = '" + this.comboBoxSWInsulation.SelectedItem + "'" +
                    " AND Fi.[Wall material] = '" + this.comboBoxSWWallMaterial.SelectedItem + "'" +
                    " AND Fi.[Ventilation 1] = '" + this.comboBoxSWVentilation.SelectedItem + "'";

            Console.WriteLine("Writing sql query with:" + this.comboBoxSwWindow.SelectedItem +
                " " + this.comboBoxSWInsulation.SelectedItem +
                " " + this.comboBoxSWWallMaterial.SelectedItem +
                " " + this.comboBoxSWVentilation.SelectedItem);

            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand dbcomm = new SqlCommand();
            SqlDataReader reader = null;
            try
            {
                conn.Open();
                dbcomm.CommandType = CommandType.Text;
                dbcomm.CommandText = SQlString;
                dbcomm.Connection = conn;
                reader = dbcomm.ExecuteReader();

                int columnOrdial = 0;
                reader.Read();

                while (columnOrdial < 21)
                {
                    try
                    {
                        //Console.WriteLine("writes from reader, avg: " + reader.GetValue(columnOrdial).ToString());
                        double dec = Convert.ToDouble(reader.GetValue(columnOrdial));
                        Console.WriteLine("writes from reader, avg: " + dec);
                        this.facadeStdDev[columnOrdial] = dec;
                        double db = Convert.ToDouble(reader.GetValue(21 + columnOrdial));
                        Console.WriteLine("writes from reader, stdev: " + db);
                        this.facadeAvg[columnOrdial] = db;
                        columnOrdial++;
                    }
                    catch (System.Data.SqlTypes.SqlNullValueException)
                    {
                        MessageBox.Show("No data available");
                        return null;
                        //break;
                    }
                    catch (System.InvalidCastException)
                    {
                        MessageBox.Show("No data available");
                        return null;
                        //break;
                    }
                }

                this.numOfFa = reader.GetInt32(42);
                Console.WriteLine("writes from reader, num: " + this.numOfFa.ToString());

            }
            catch (InvalidOperationException ex)
            {
                MessageBox.Show(ex.Message);
            }
            catch (SqlException ex)
            {
                MessageBox.Show(ex.Message);
            }
            if (reader != null)
            {
                reader.Close();
            }

            facadeString = SQlString;
            conn.Close();
             *              * */
            facadeAvg = new double[] { 21.6, 22.5, 22.3, 20.4, 21.9, 25.7, 27.1, 30.3, 31.2, 33.2, 34.8, 35.4, 37.6, 37.4, 38.3, 37.3, 37.5, 40.6, 41.9, 42.3, 42 };
            this.numOfFa = 7;
            return facadeAvg;
        }
        #endregion

        #region Window GUI control
        private void comboBoxWindowType_SelectedIndexChanged_1(object sender, EventArgs e)
         {
            Console.WriteLine("selected index shifted" + this.comboBoxWindowType.SelectedItem);
            if (this.comboBoxWindowType.SelectedItem.ToString() == "Single glazing")
            {
                this.label1glassthickness.Enabled = true;
                this.label1interpanespace.Enabled = false;
                this.label2glassthickness.Enabled = false;
                this.label2interpanespace.Enabled = false;
                this.label3glassthickness.Enabled = false;
                this.textBox1glasssthickness.Enabled = true;
                this.textBox1interpanespace.Enabled = false;
                this.textBox2glassthickness.Enabled = false;
                this.textBox2interpnaespace.Enabled = false;
                this.textBox3glassthickness.Enabled = false;
                this.Refresh();

            }
            else if (this.comboBoxWindowType.SelectedItem.ToString() == "Double glazing")
            {
                this.label1glassthickness.Enabled = true;
                this.label1interpanespace.Enabled = true;
                this.label2glassthickness.Enabled = true;
                this.label2interpanespace.Enabled = false;
                this.label3glassthickness.Enabled = false;
                this.textBox1glasssthickness.Enabled = true;
                this.textBox1interpanespace.Enabled = true;
                this.textBox2glassthickness.Enabled = true;
                this.textBox2interpnaespace.Enabled = false;
                this.textBox3glassthickness.Enabled = false;
                this.Refresh();
            }
            else
            {
                MessageBox.Show("No data for triple windows implemented yet");
                this.label1glassthickness.Enabled = true;
                this.label1interpanespace.Enabled = true;
                this.label2glassthickness.Enabled = true;
                this.label2interpanespace.Enabled = true;
                this.label3glassthickness.Enabled = true;
                this.textBox1glasssthickness.Enabled = true;
                this.textBox1interpanespace.Enabled = true;
                this.textBox2glassthickness.Enabled = true;
                this.textBox2interpnaespace.Enabled = true;
                this.textBox3glassthickness.Enabled = true;
                this.Refresh();
            }
            this.Refresh();
        }
        #endregion

        #region Setting Material Data
        public void setMatData(double gDens, double gEMod, double gPoi, double gLoss, double aDen, double aSpeed)
        {
            this.mat.gDens = gDens;
            this.mat.gEMod = gEMod;
            this.mat.gPoi = gPoi;
            this.mat.gLoss = gLoss;
            this.mat.aDen = aDen;
            this.mat.aSpeed = aSpeed;
        }
        #endregion

        #region ComboBox Wall Material
        private void comboBoxWallMaterial_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.comboBoxWallMaterial.Text == "Wood, light")
            {
                this.comboBoxRwCtrWallMAterial.Text = "47";
            }
            else if (this.comboBoxWallMaterial.Text == "Wood, heavy")
            {
                this.comboBoxRwCtrWallMAterial.Text = "32";
            }
            else if (this.comboBoxWallMaterial.Text == "Masonry/concrete")
            {
                this.comboBoxRwCtrWallMAterial.Text = "56";
            }
            else
            {
            }
        }
        #endregion

        #region button3_Click Show wall def
        private void button3_Click(object sender, EventArgs e)
        {
            int i = 0; //0:wall,
            Wall wall = new Wall(i, wallData, null, null, null, null);
            wall.Show();
        }
        #endregion

        #region Sets Wall Data 
        //Used for Wall and Window Data
        public void setWallData(int i)
        {
            if (i == 0) //0 =  wall
            {
                //this.wallData = WallData()
            }
            else //1 = window
            {
                //this.windowData = 
            }
        }
#endregion

        #region button_click2 Setting Material Data
        private void button2_Click(object sender, EventArgs e)
        {

            Material matForm = new Material(mat);
            matForm.Show();
            mat = matForm.getMatData();
            Console.WriteLine(this.mat.gDens.ToString() + " " +
            this.mat.gEMod.ToString() + " " +
            this.mat.gPoi.ToString() + " " +
            this.mat.gLoss.ToString() + " " +
            this.mat.aDen.ToString() + " " +
            this.mat.aSpeed.ToString() + " ");
        }
        #endregion

        #region button4_Click Show window def
        private void button4_Click(object sender, EventArgs e)
        {
            int i = 1; //1:window,
            Wall wall = new Wall(i, null, windowData, null, null, null);
            wall.Show();
        }
        #endregion

        #region checkBow Window definition
        private void checkBoxWindowDef_CheckedChanged_1(object sender, EventArgs e)
        {

            if (checkBoxWindowDef.Checked == true)
            {
                this.button4.Enabled = true;
                this.comboBoxWindowType.Enabled = false;
                this.textBox1glasssthickness.Enabled = false;
                this.textBox1interpanespace.Enabled = false;
                this.textBox2glassthickness.Enabled = false;
                this.textBox2interpnaespace.Enabled = false;
                this.textBox3glassthickness.Enabled = false;
                this.button2.Enabled = false;
            }
            else
            {
                this.button4.Enabled = false;
                this.comboBoxWindowType.Enabled = true;
                this.textBox1glasssthickness.Enabled = true;
                this.textBox1interpanespace.Enabled = true;
                this.textBox2glassthickness.Enabled = true;
                this.textBox2interpnaespace.Enabled = true;
                this.textBox3glassthickness.Enabled = true;
                comboBoxWindowType_SelectedIndexChanged_1(true, null);
                this.button2.Enabled = true;
            }
        }
        #endregion

        #region CheckBox Wall Definition
        private void checkBoxWallDef_CheckedChanged_1(object sender, EventArgs e)
        {
            if (checkBoxWallDef.Checked == true)
            {
                this.comboBoxWallMaterial.Enabled = false;
                this.comboBoxRwCtrWallMAterial.Enabled = false;
                this.comboBoxVentilation.Enabled = false;
                this.comboBoxInsulation.Enabled = false;
                this.button3.Enabled = true;
            }
            else
            {
                this.comboBoxWallMaterial.Enabled = true;
                this.comboBoxRwCtrWallMAterial.Enabled = true;
                this.comboBoxVentilation.Enabled = true;
                this.comboBoxInsulation.Enabled = true;
                this.button3.Enabled = false;
            }
        }
        #endregion

        #region Setting reverberation time
        private void radioButtonSmallDamp_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonSmallDamp.Checked == true)
            {
                revTime = new double[] { 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5 };
            }
        }

        private void radioButtonMedDamping_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonMedDamping.Checked == true)
            {
                revTime = new double[] { 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5 };
            
            }
        }

        private void radioButtonFullDamping_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonFullDamping.Checked == true)
            {
                revTime = new double[] { 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3, 0.3 };
            }
        }
        #endregion

        #region Setting calculating method
        // 0 = R
        // 1 = D
        // 2 = Dn
        // 3 = DnT
        // 4 = Dls2m
        private void radioButtonR_CheckedChanged_1(object sender, EventArgs e)
        {
            if (radioButtonR.Checked == true)
            {
                calcMeth = 0;
            }
        }

        private void radioButtonD_CheckedChanged_1(object sender, EventArgs e)
        {
            if (radioButtonD.Checked == true)
            {
                calcMeth = 1;
            }
        }

        private void radioButtonDn_CheckedChanged_1(object sender, EventArgs e)
        {
            if (radioButtonDn.Checked == true)
            {
                calcMeth = 2;
            }
        }

        private void radioButtonDnT_CheckedChanged_1(object sender, EventArgs e)
        {
            if (radioButtonDnT.Checked == true)
            {
                calcMeth = 3;
            }
        }

        private void radioButtonDls2m_CheckedChanged_1(object sender, EventArgs e)
        {

            if (radioButtonDls2m.Checked == true)
            {
                calcMeth = 4;
            }
        }
        #endregion

        #region Checkbox reverberation time definition
        private void checkBoxDefRevTime_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxDefRevTime.Checked == true)
            {
                this.button11.Enabled = true;
                this.radioButtonFullDamping.Enabled = false;
                this.radioButtonMedDamping.Enabled = false;
                this.radioButtonSmallDamp.Enabled = false;
            }
            else
            {
                this.button11.Enabled = false;
                this.radioButtonFullDamping.Enabled = true;
                this.radioButtonMedDamping.Enabled = true;
                this.radioButtonSmallDamp.Enabled = true;
            }
        }
        #endregion

        #region buttoni11_Click Show reverberation time
        private void button11_Click(object sender, EventArgs e)
        {
            int i = 2; //2:revData,
            Wall wall = new Wall(i, null, null, revData,null, null);
            wall.Show();
        }
        #endregion

        #region GUI options checkbox stdspectrum
        private void checkBoxStdSpc_CheckedChanged(object sender, EventArgs e)
        {

            if (checkBoxStdSpc.Checked == true)
            {
                this.comboBoxStdSpectrum.Enabled = false;
                this.textBoxOutdoorLevel.Enabled = false;
                this.button12.Enabled = true;
                this.textBoxTrCritical.Enabled = false;
                this.textBoxTrCritical2.Enabled = false;
                this.textBoxTrDistance.Enabled = false;
                this.textBoxTrDistance2.Enabled = false;
                this.textBoxTrSpeed.Enabled = false;
                this.textBoxTrSpeed2.Enabled = false;
            }
            else
            {
                this.comboBoxStdSpectrum.Enabled = true;
                this.textBoxOutdoorLevel.Enabled = true;
                this.button12.Enabled = false;
                this.textBoxTrCritical.Enabled = true;
                this.textBoxTrCritical2.Enabled = true;
                this.textBoxTrDistance.Enabled = true;
                this.textBoxTrDistance2.Enabled = true;
                this.textBoxTrSpeed.Enabled = true;
                this.textBoxTrSpeed2.Enabled = true;
            }
        }
        #endregion

        #region button12_click Show outdoor spectrum
        private void button12_Click(object sender, EventArgs e)
        {
            int i = 8; //8:outdoor spectrum,
            Wall wall = new Wall(i, null, null, null, null, outData);
            wall.Show();
        }
        #endregion

        #region Gui options Updates textboxes for area
        private void textBoxWinDimA_TextChanged(object sender, EventArgs e)
        {
            try
            {
                this.textBoxAreaWindow.Text = (Convert.ToDouble(this.textBoxWinDimA.Text) * Convert.ToDouble(this.textBoxWinDimB.Text)).ToString();             

            }
            catch (System.FormatException)
            {
                //Do nothing
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
            }
        }

        private void textBoxWinDimB_TextChanged(object sender, EventArgs e)
        {
            try
            {
                 this.textBoxAreaWindow.Text = (Convert.ToDouble(this.textBoxWinDimA.Text) * Convert.ToDouble(this.textBoxWinDimB.Text)).ToString();
             }
             catch (System.FormatException)
             {
                 //Do nothing
             }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
            }
        }

        private void textBoxAreaWindow_TextChanged(object sender, EventArgs e)
        {
            try
            {
                this.textBoxFacadeArea.Text = (Convert.ToDouble(this.textBoxAreaWindow.Text) + Convert.ToDouble(this.textBoxAreaWall.Text)).ToString();  
             }
        
             catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
            }
        }

        private void textBoxAreaWall_TextChanged(object sender, EventArgs e)
        {
            try
            {
                this.textBoxFacadeArea.Text = (Convert.ToDouble(this.textBoxAreaWindow.Text) + Convert.ToDouble(this.textBoxAreaWall.Text)).ToString();
            }

            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
            }
        }
        #endregion

        #region For realses only
        private void comboBoxInsulation_SelectedIndexChanged(object sender, EventArgs e)
        {
            MessageBox.Show("No insulation data implemented yet");
        }

        private void comboBoxVentilation_SelectedIndexChanged(object sender, EventArgs e)
        {
            MessageBox.Show("No ventilation data implemented yet");
        }

        private void label57_Click(object sender, EventArgs e)
        {
            Process.Start("mailto:knutha@gmail.com", "");
        }

        private void labelLes_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Not yet available");
        }
#endregion
    }
}