using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Stairway
{
    public partial class Material : Form
    {
        public double gDens;
        public double gEMod;
        public double gPoi;
        public double gLoss;
        public double aDen;
        public double aSpeed;
        MaterialData matData = new MaterialData(0,0,0,0,0,0);

        public Material(MaterialData mat)
        {
            matData = mat;
            this.gDens = mat.gDens;
            this.gEMod = mat.gEMod;
            this.gPoi = mat.gPoi;
            this.gLoss = mat.gLoss;
            this.aDen = mat.aDen;
            this.aSpeed = mat.aSpeed;

            InitializeComponent();

            this.textBoxDen.Text = this.gDens.ToString();
            this.textBoxEMod.Text = (this.gEMod / Math.Pow(10, 9)).ToString();
            this.textBoxPoi.Text = this.gPoi.ToString();
            this.textBoxLoss.Text = this.gLoss.ToString();
            this.textBoxADen.Text = this.aDen.ToString();
            this.textBoxASpeed.Text = this.aSpeed.ToString();
            this.Refresh();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            gDens = Convert.ToDouble(this.textBoxDen.Text);
            gEMod = Convert.ToDouble(this.textBoxEMod.Text) * Math.Pow(10, 9);
            gPoi = Convert.ToDouble(this.textBoxPoi.Text);
            gLoss = Convert.ToDouble(this.textBoxLoss.Text);
            aDen = Convert.ToDouble(this.textBoxADen.Text);
            aSpeed = Convert.ToDouble(this.textBoxASpeed.Text);

            matData.setMatData(gDens, gEMod, gPoi, gLoss, aDen, aSpeed);

            MessageBox.Show("Parameters set!");
        }

        public MaterialData getMatData()
        {
            return matData;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

      
    }
}