using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Stairway
{
    public partial class Wall : Form
    {
        double[] freqs =  new double[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        int i;
        WallData wallData;
        WindowData windowdata;
        RevData revData;
        double[] insulationData;
        OutdoorData outdoorData;

        public Wall(int i, WallData wData, WindowData wiData, RevData rData, double[] insData, OutdoorData oData)
        {
            this.i = i;
            this.wallData = wData;
            this.windowdata = wiData;
            this.revData = rData;
            this.insulationData = insData;
            this.outdoorData = oData;

            InitializeComponent();

            if (i == 0) //0 = wall
            {
                this.labelHeader.Text = "Define wall insulation curve:";
                this.Text = "Wall insulation";
                
                //Setting text from walldata
                try
                {
                    double[] freqs = wallData.getWallData();
                    this.textBox1.Text = freqs[0].ToString();
                    this.textBox2.Text = freqs[1].ToString();
                    this.textBox3.Text = freqs[2].ToString();
                    this.textBox4.Text = freqs[3].ToString();
                    this.textBox5.Text = freqs[4].ToString();
                    this.textBox6.Text = freqs[5].ToString();
                    this.textBox7.Text = freqs[6].ToString();
                    this.textBox8.Text = freqs[7].ToString();
                    this.textBox9.Text = freqs[8].ToString();
                    this.textBox10.Text = freqs[9].ToString();
                    this.textBox11.Text = freqs[10].ToString();
                    this.textBox12.Text = freqs[11].ToString();
                    this.textBox13.Text = freqs[12].ToString();
                    this.textBox14.Text = freqs[13].ToString();
                    this.textBox15.Text = freqs[14].ToString();
                    this.textBox16.Text = freqs[15].ToString();
                    this.textBox17.Text = freqs[16].ToString();
                    this.textBox18.Text = freqs[17].ToString();
                    this.textBox19.Text = freqs[18].ToString();
                    this.textBox20.Text = freqs[19].ToString();
                    this.textBox21.Text = freqs[20].ToString();
                    

                }
                catch (Exception exp)
                {
                    MessageBox.Show(exp.Message);
                }
            }
            else if (i == 1) //1 = window
            {
                this.labelHeader.Text = "Define window insulation curve:";
                this.Text = "Window insulation";
                
                //Setting text from windowdata
                try
                {
                    double[] freqs = windowdata.getWindowData();
                    this.textBox1.Text = freqs[0].ToString();
                    this.textBox2.Text = freqs[1].ToString();
                    this.textBox3.Text = freqs[2].ToString();
                    this.textBox4.Text = freqs[3].ToString();
                    this.textBox5.Text = freqs[4].ToString();
                    this.textBox6.Text = freqs[5].ToString();
                    this.textBox7.Text = freqs[6].ToString();
                    this.textBox8.Text = freqs[7].ToString();
                    this.textBox9.Text = freqs[8].ToString();
                    this.textBox10.Text = freqs[9].ToString();
                    this.textBox11.Text = freqs[10].ToString();
                    this.textBox12.Text = freqs[11].ToString();
                    this.textBox13.Text = freqs[12].ToString();
                    this.textBox14.Text = freqs[13].ToString();
                    this.textBox15.Text = freqs[14].ToString();
                    this.textBox16.Text = freqs[15].ToString();
                    this.textBox17.Text = freqs[16].ToString();
                    this.textBox18.Text = freqs[17].ToString();
                    this.textBox19.Text = freqs[18].ToString();
                    this.textBox20.Text = freqs[19].ToString();
                    this.textBox21.Text = freqs[20].ToString();

                }
                catch (Exception exp)
                {
                    MessageBox.Show(exp.Message);
                }
            }

            else if (i == 2) //2 = wall
            {
                this.labelHeader.Text = "Define reverberation time curve:";
                this.Text = "Reverberation time";
                this.label24.Text = "s";
                this.label25.Text = "s";
                //Setting text from walldata
                try
                {
                    double[] freqs = revData.getRevData();
                    this.textBox1.Text = freqs[0].ToString();
                    this.textBox2.Text = freqs[1].ToString();
                    this.textBox3.Text = freqs[2].ToString();
                    this.textBox4.Text = freqs[3].ToString();
                    this.textBox5.Text = freqs[4].ToString();
                    this.textBox6.Text = freqs[5].ToString();
                    this.textBox7.Text = freqs[6].ToString();
                    this.textBox8.Text = freqs[7].ToString();
                    this.textBox9.Text = freqs[8].ToString();
                    this.textBox10.Text = freqs[9].ToString();
                    this.textBox11.Text = freqs[10].ToString();
                    this.textBox12.Text = freqs[11].ToString();
                    this.textBox13.Text = freqs[12].ToString();
                    this.textBox14.Text = freqs[13].ToString();
                    this.textBox15.Text = freqs[14].ToString();
                    this.textBox16.Text = freqs[15].ToString();
                    this.textBox17.Text = freqs[16].ToString();
                    this.textBox18.Text = freqs[17].ToString();
                    this.textBox19.Text = freqs[18].ToString();
                    this.textBox20.Text = freqs[19].ToString();
                    this.textBox21.Text = freqs[20].ToString();


                }
                catch (Exception exp)
                {
                    MessageBox.Show(exp.Message);
                }
            }


            else if (i ==9) // 9 = insulation
            {
                this.labelHeader.Text = "Insulation Data curve:";
                this.Text = "Total facade insulation";
                this.label24.Text = "R'  ";
                this.label25.Text = "R'  ";
                
                //Setting text from walldata
                try
                {
                    double[] freqs = insData;
                    this.button1.Visible = false;
                    this.textBox1.Text = Math.Round(freqs[0],1).ToString();
                    this.textBox2.Text = Math.Round(freqs[1], 1).ToString();
                    this.textBox3.Text = Math.Round(freqs[2], 1).ToString();
                    this.textBox4.Text = Math.Round(freqs[3], 1).ToString();
                    this.textBox5.Text = Math.Round(freqs[4], 1).ToString();
                    this.textBox6.Text = Math.Round(freqs[5], 1).ToString();
                    this.textBox7.Text = Math.Round(freqs[6], 1).ToString();
                    this.textBox8.Text = Math.Round(freqs[7], 1).ToString();
                    this.textBox9.Text = Math.Round(freqs[8], 1).ToString();
                    this.textBox10.Text = Math.Round(freqs[9], 1).ToString();
                    this.textBox11.Text = Math.Round(freqs[10], 1).ToString();
                    this.textBox12.Text = Math.Round(freqs[11], 1).ToString();
                    this.textBox13.Text = Math.Round(freqs[12], 1).ToString();
                    this.textBox14.Text = Math.Round(freqs[13], 1).ToString();
                    this.textBox15.Text = Math.Round(freqs[14], 1).ToString();
                    this.textBox16.Text = Math.Round(freqs[15], 1).ToString();
                    this.textBox17.Text = Math.Round(freqs[16], 1).ToString();
                    this.textBox18.Text = Math.Round(freqs[17], 1).ToString();
                    this.textBox19.Text = Math.Round(freqs[18], 1).ToString();
                    this.textBox20.Text = Math.Round(freqs[19], 1).ToString();
                    this.textBox21.Text = Math.Round(freqs[20], 1).ToString();
                    

                }
                catch (Exception exp)
                {
                    MessageBox.Show(exp.Message);
                }
            }
            else // 8 = outdoor spectrum
            {
                this.labelHeader.Text = "Outdoor spectrum:";
                this.Text = "Outdoor Spectrum";
                this.label24.Text = "L_A";
                this.label25.Text = "L_A";
                
                //Setting text from walldata
                try
                {
                    double[] freqs = outdoorData.getOutdoorData(); ;
                    this.textBox1.Text = Math.Round(freqs[0],1).ToString();
                    this.textBox2.Text = Math.Round(freqs[1], 1).ToString();
                    this.textBox3.Text = Math.Round(freqs[2], 1).ToString();
                    this.textBox4.Text = Math.Round(freqs[3], 1).ToString();
                    this.textBox5.Text = Math.Round(freqs[4], 1).ToString();
                    this.textBox6.Text = Math.Round(freqs[5], 1).ToString();
                    this.textBox7.Text = Math.Round(freqs[6], 1).ToString();
                    this.textBox8.Text = Math.Round(freqs[7], 1).ToString();
                    this.textBox9.Text = Math.Round(freqs[8], 1).ToString();
                    this.textBox10.Text = Math.Round(freqs[9], 1).ToString();
                    this.textBox11.Text = Math.Round(freqs[10], 1).ToString();
                    this.textBox12.Text = Math.Round(freqs[11], 1).ToString();
                    this.textBox13.Text = Math.Round(freqs[12], 1).ToString();
                    this.textBox14.Text = Math.Round(freqs[13], 1).ToString();
                    this.textBox15.Text = Math.Round(freqs[14], 1).ToString();
                    this.textBox16.Text = Math.Round(freqs[15], 1).ToString();
                    this.textBox17.Text = Math.Round(freqs[16], 1).ToString();
                    this.textBox18.Text = Math.Round(freqs[17], 1).ToString();
                    this.textBox19.Text = Math.Round(freqs[18], 1).ToString();
                    this.textBox20.Text = Math.Round(freqs[19], 1).ToString();
                    this.textBox21.Text = Math.Round(freqs[20], 1).ToString();
                }
                catch (Exception exp)
                {
                    MessageBox.Show(exp.Message);
                }
            }

      }
       


        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                if (i == 0)//0 = wall
                {
                    freqs[0] = Convert.ToDouble(this.textBox1.Text);
                    freqs[1] = Convert.ToDouble(this.textBox2.Text);
                    freqs[2] = Convert.ToDouble(this.textBox3.Text);
                    freqs[3] = Convert.ToDouble(this.textBox4.Text);
                    freqs[4] = Convert.ToDouble(this.textBox5.Text);
                    freqs[5] = Convert.ToDouble(this.textBox6.Text);
                    freqs[6] = Convert.ToDouble(this.textBox7.Text);
                    freqs[7] = Convert.ToDouble(this.textBox8.Text);
                    freqs[8] = Convert.ToDouble(this.textBox9.Text);
                    freqs[9] = Convert.ToDouble(this.textBox10.Text);
                    freqs[10] = Convert.ToDouble(this.textBox11.Text);
                    freqs[11] = Convert.ToDouble(this.textBox12.Text);
                    freqs[12] = Convert.ToDouble(this.textBox13.Text);
                    freqs[13] = Convert.ToDouble(this.textBox14.Text);
                    freqs[14] = Convert.ToDouble(this.textBox15.Text);
                    freqs[15] = Convert.ToDouble(this.textBox16.Text);
                    freqs[16] = Convert.ToDouble(this.textBox17.Text);
                    freqs[17] = Convert.ToDouble(this.textBox18.Text);
                    freqs[18] = Convert.ToDouble(this.textBox19.Text);
                    freqs[19] = Convert.ToDouble(this.textBox20.Text);
                    freqs[20] = Convert.ToDouble(this.textBox21.Text);

                    wallData.setWallData(freqs);

                }
                else if (i == 1)//i = window
                {
                    freqs[0] = Convert.ToDouble(this.textBox1.Text);
                    freqs[1] = Convert.ToDouble(this.textBox2.Text);
                    freqs[2] = Convert.ToDouble(this.textBox3.Text);
                    freqs[3] = Convert.ToDouble(this.textBox4.Text);
                    freqs[4] = Convert.ToDouble(this.textBox5.Text);
                    freqs[5] = Convert.ToDouble(this.textBox6.Text);
                    freqs[6] = Convert.ToDouble(this.textBox7.Text);
                    freqs[7] = Convert.ToDouble(this.textBox8.Text);
                    freqs[8] = Convert.ToDouble(this.textBox9.Text);
                    freqs[9] = Convert.ToDouble(this.textBox10.Text);
                    freqs[10] = Convert.ToDouble(this.textBox11.Text);
                    freqs[11] = Convert.ToDouble(this.textBox12.Text);
                    freqs[12] = Convert.ToDouble(this.textBox13.Text);
                    freqs[13] = Convert.ToDouble(this.textBox14.Text);
                    freqs[14] = Convert.ToDouble(this.textBox15.Text);
                    freqs[15] = Convert.ToDouble(this.textBox16.Text);
                    freqs[16] = Convert.ToDouble(this.textBox17.Text);
                    freqs[17] = Convert.ToDouble(this.textBox18.Text);
                    freqs[18] = Convert.ToDouble(this.textBox19.Text);
                    freqs[19] = Convert.ToDouble(this.textBox20.Text);
                    freqs[20] = Convert.ToDouble(this.textBox21.Text);

                    windowdata.setWindowData(freqs);
                }
                else if(i == 2)//2 = revTime
                {
                    freqs[0] = Convert.ToDouble(this.textBox1.Text);
                    freqs[1] = Convert.ToDouble(this.textBox2.Text);
                    freqs[2] = Convert.ToDouble(this.textBox3.Text);
                    freqs[3] = Convert.ToDouble(this.textBox4.Text);
                    freqs[4] = Convert.ToDouble(this.textBox5.Text);
                    freqs[5] = Convert.ToDouble(this.textBox6.Text);
                    freqs[6] = Convert.ToDouble(this.textBox7.Text);
                    freqs[7] = Convert.ToDouble(this.textBox8.Text);
                    freqs[8] = Convert.ToDouble(this.textBox9.Text);
                    freqs[9] = Convert.ToDouble(this.textBox10.Text);
                    freqs[10] = Convert.ToDouble(this.textBox11.Text);
                    freqs[11] = Convert.ToDouble(this.textBox12.Text);
                    freqs[12] = Convert.ToDouble(this.textBox13.Text);
                    freqs[13] = Convert.ToDouble(this.textBox14.Text);
                    freqs[14] = Convert.ToDouble(this.textBox15.Text);
                    freqs[15] = Convert.ToDouble(this.textBox16.Text);
                    freqs[16] = Convert.ToDouble(this.textBox17.Text);
                    freqs[17] = Convert.ToDouble(this.textBox18.Text);
                    freqs[18] = Convert.ToDouble(this.textBox19.Text);
                    freqs[19] = Convert.ToDouble(this.textBox20.Text);
                    freqs[20] = Convert.ToDouble(this.textBox21.Text);

                    revData.setRevData(freqs);
                }

                else if (i == 8)//8 = Outdoor spectrum
                {
                    freqs[0] = Convert.ToDouble(this.textBox1.Text);
                    freqs[1] = Convert.ToDouble(this.textBox2.Text);
                    freqs[2] = Convert.ToDouble(this.textBox3.Text);
                    freqs[3] = Convert.ToDouble(this.textBox4.Text);
                    freqs[4] = Convert.ToDouble(this.textBox5.Text);
                    freqs[5] = Convert.ToDouble(this.textBox6.Text);
                    freqs[6] = Convert.ToDouble(this.textBox7.Text);
                    freqs[7] = Convert.ToDouble(this.textBox8.Text);
                    freqs[8] = Convert.ToDouble(this.textBox9.Text);
                    freqs[9] = Convert.ToDouble(this.textBox10.Text);
                    freqs[10] = Convert.ToDouble(this.textBox11.Text);
                    freqs[11] = Convert.ToDouble(this.textBox12.Text);
                    freqs[12] = Convert.ToDouble(this.textBox13.Text);
                    freqs[13] = Convert.ToDouble(this.textBox14.Text);
                    freqs[14] = Convert.ToDouble(this.textBox15.Text);
                    freqs[15] = Convert.ToDouble(this.textBox16.Text);
                    freqs[16] = Convert.ToDouble(this.textBox17.Text);
                    freqs[17] = Convert.ToDouble(this.textBox18.Text);
                    freqs[18] = Convert.ToDouble(this.textBox19.Text);
                    freqs[19] = Convert.ToDouble(this.textBox20.Text);
                    freqs[20] = Convert.ToDouble(this.textBox21.Text);

                    outdoorData.setOutdoorData(freqs);
                }
                else
                {
                }
            }
            catch (System.FormatException exp)
            {
                MessageBox.Show(exp.Message);
            }
            MessageBox.Show("Data set!");
            this.Close();
        
        
        }
    }
}