clear all;
%close all;
clc

f=[ 10 12.5 16 20 25 31.5 40 50 63 80 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 6300 8000 10000 12500 16000 20000];
f2 = [18 19 22 20 21 20 19 18 24 22 28 29 33 34 37 39 40 41 39 33 34];
f6126 =  [16 25 23 17 22 26 27 30 32 32 33 33 30 26 29 30] 
fm = [100,125,160,200,250,315,400,500,630,800,1000,...
1250,1600,2000,2500,3150];
f=0:10:5000

c = 344;
d = 1.21;

dg = 2500;
E = 60*10^(9);
p = 0.3;
nloss = 0.05;

m1a = 1.15;
m1b = 1.15;
h1 = 0.006;
m1 =  h1 * dg ;

m2a = 1.15;
m2b = 1.15;
h2 = 0.006;
m2 = h2 * dg ;
s = 0.012;


%Regner ut dobbeltveggresonansen:
f0 =  60* sqrt((m1+m2)/(m1*m2*s))

%Regner ut koinsidensfrekvensen:
fc = ((c^2 )/ (1.81*h1))*sqrt((dg*(1-p^2)) / E) 

R1 = predsingle(m1,h1,m1a,m1b,nloss,f)%20*LOG10((pi*f(n)*m1)/(d*c)) - 5.5;
R2 = predsingle(m2,h2,m2a,m2b,nloss,f)%20*LOG10((pi*f(n)*m2)/(d*c)) - 5.5;
    
for n=1:length(f)
    S(n) =  20*LOG10((pi*f(n)*(m1+m2))/(d*c)) - 5.5;
    P(n) =  R1(n) + R2(n) - 29;
    R3(n) = 20*LOG10((pi*f(n)*(2*(m1+m2)/3))/(d*c))  ; %-5 fra bies og hansen 80 graders in-situ innfalssvinkel 
    if (n > 1)
        R4(n) = R1(n-1) + R2(n-1) -29;
    end
end


n1 = 1
n2 = 1

for n=1:length(f)
    if f(n) < 2*f0/3                       % stivhetsstyrt
        R(n) = 20*LOG10((pi*f(n)*(m1+m2))/(d*c)) - 5.5;
         n1 = n;
    elseif f(n) < fc/5             % masseloven
        R(n) = R1(n) + R2(n) - 29; %-5 fra bies og hansen 80 graders in-situ innfalssvinkel 
        if n > 1 & (f(n-1) < f0);
            n2 = n 
        end
    elseif f(n) < 0.71*fc               % masseloven
        R(n) =  20*LOG10((pi*f(n)*(2*(m1+m2)/3))/(d*c)) - 9; %-5 fra bies og hansen 80 graders in-situ innfalssvinkel 
       
    elseif f(n) > fc/7                      % over grensefrekvensen
       R(n) = R1(n) + R2(n) -29; % -5 for 80 graders innfallsevinkel som i bies og hansen i felt
   end
end

for n=1:length(f)
    S(n) =  20*LOG10((pi*f(n)*(m1+m2))/(d*c)) - 5.5;
    P(n) =  R1(n) + R2(n) - 29;
end


AA = 20.0/(f(n1)*log(10));
BB = 2 * 20.0/(f(n1)*log(10));
%(f(n2)*d*c*log(10))

[ad bd cd dd] = Interpol(f(n1),S(n1),f(n2),P(n2),AA,BB);

for n=1:length(f)
    if f(n) > 2*f0/3 & f(n) < f0    % plat
        R(n) = ad*(f(n)^3) + bd*(f(n)^2) + cd*f(n) +dd;     
    end 
end

no=5;
figure('Position',[100 100 500 500*(13.5/11.2)/6*no*(13.5/11.2)/(14.65/11.5)],'Color',[1 1 1]);
semilogx(f,R,'b')
hold on
semilogx(fm,f6126,'r')
axis([50 5000 0 60])  
legend('beregnet','mlt',2)
xlabel('Frekvens [Hz]','FontWeight','normal','FontSize',12)
ylabel('Reduksjonstall [dB]','FontWeight','normal','FontSize',12)
title('Reduksjonstall for dobbeltpanel','FontWeight','normal','FontSize',14)
set(gca,'FontSize',8)
set(gca,'XTick',[ 50 63 80 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 ])
set(gca,'XTickLabel',{ '50' '' '63' '' '' '125' '' '' '250' '' '' '500' '' '' '1000' '' '' '2000' '' '' '4000' '' },'FontSize',8)

%Plotter vertikale hjelpelinjer
dBmin=-10;
dBmax=130+dBmin;

plot([100 100],[dBmin+0.8 dBmax-0.7],'k:','Color',[0.6 0.6 0.6])
plot([3150 3150],[dBmin+0.8 dBmax-0.7],'k:','Color',[0.6 0.6 0.6])

plot([63 63],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([125 125],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([250 250],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([500 500],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([1000 1000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([2000 2000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([4000 4000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])

%Plotter horisontale hjelpelinjer
for i=1:dBmax/10-dBmin/10-1,
   plot([50 5000],[dBmax-i*10 dBmax-i*10],'Color',[0.6 0.6 0.6])
end
   