clc;
clear all;
%close all;

%frekvens i 1/3 oktavbnd
f=[ 10 12.5 16 20 25 31.5 40 50 63 80 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 6300 8000 10000 12500 16000 20000];
f2=[ 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 ];

r4mm = [23 23 24 24 24 25 27 27 29 32 32 32 34 31 29 24]
r10mm = [29 33 30 29 31 30 31 32 34 35 32 26 28 32 35 38]
r6mm = [22 25 26 28 27 27 28 29 31 31 34 34 31 29 24 28]

%smalbnd regner for hver 1 Hz 
%f=1:2:10000;

%materialparameters
c = 344;
d = 1.21;
dg = 2500;
E = 60*10^(9);
p = 0.3;
nloss = 0.015;

%windowdimensions
ma = 1.5;
mb = 1.5;
h = 0.006;
m =  h * dg ;

%Regner ut koinsidensfrekvensen:
fc = ((c^2 )/ (1.81*h))*sqrt((dg*(1-p^2)) / E) 

%Regner ut frste egenmoden til platen:
fnm = pi/2 * sqrt((E*h^2) / ((12*dg) * (1-p^2))) * ((1/ma)^2 + (1/mb)^2 )

for n=1:length(f)
    S(n) = 20*LOG10((pi*f(n)*m)/(d*c)) - 5.5;
    P(n) = 20*LOG10((pi*f(n)*m)/(d*c)) + 10 *log10((2*nloss*f(n)) / (pi*fc)) -5.5;
end


n1 = 1
n2 = 1

R2 = zeros(length(f));

for n=1:length(f)
    if f(n) < fnm                       % stivhetsstyrt
        R(n) = -20*LOG10((pi*f(n)*m)/(d*c)) + 20*LOG10((pi*fnm*m)/(d*c)) - 5.5; %-5 fra Bies og Hansen
    elseif f(n) < fc/2                 % masseloven
        R(n) = 20*LOG10((pi*f(n)*m)/(d*c)) - 5.5; %-5 fra bies og hansen 80 graders in-situ innfalssvinkel 
        n1 = n;
    else f(n) > fc                      % over grensefrekvensen
        R(n) = 20*LOG10((pi*f(n)*m)/(d*c)) + 10 *log10((2*nloss*f(n)) / (pi*fc)) -5.5; % -5 for 80 graders innfallsevinkel som i bies og hansen i felt
        if n > 1 & (f(n-1) < fc);
            n2 = n 
        end
    end
end

AA = 20.0/(f(n1)*log(10));
BB = 20.0/(f(n2)*log(10)) + 10.0/(log(10)*f(n2));
%(f(n2)*d*c*log(10))

[ad bd cd dd] = Interpol(f(n1),S(n1),f(n2),P(n2),AA,BB);

for n=1:length(f)
    if f(n) > fc/2 & f(n) < fc    % plat
        R2(n) = ad*(f(n)^3) + bd*(f(n)^2) + cd*f(n) +dd;     
        R(n) = ad*(f(n))^3 + bd*(f(n))^2 + cd*(f(n)) +dd;
    end 
end

%[ad bd cd dd] = LLagrange(0, 0, 1, 0, 10, 10);
    
%XX = -1:0.01:2;
%for n=1:length(XX)
%    FF(n) = ad*(XX(n)^3) + bd*(XX(n)^2) + cd*XX(n) +dd;
%end

%B = 20/(f(n2)*d*c*log(10)) + 10/(log(10)*pi*fc*f(n2))

no=5;
figure('Position',[100 100 500 500*(13.5/11.2)/6*no*(13.5/11.2)/(14.65/11.5)],'Color',[1 1 1]);

%plot(XX, FF, 'r');

semilogx(f, R, 'r');
%stem(f,R,'r');
hold on
%stem(f,R2,'b');
%plot(f, R2, 'b');
plot(f2,r6mm,'b');
%plot(f,P,'r');
axis([50 5000 0 50])  
legend('beregnet','mlt',2)
xlabel('Frekvens [Hz]','FontWeight','normal','FontSize',20)
ylabel('Reduksjonstall [dB]','FontWeight','normal','FontSize',20)
title('Reduksjonstall for enkeltpanel','FontWeight','normal','FontSize',24)
set(gca,'FontSize',8)
set(gca,'XTick',[ 50 63 80 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 ])
set(gca,'XTickLabel',{ '50' '' '63' '' '' '125' '' '' '250' '' '' '500' '' '' '1000' '' '' '2000' '' '' '4000' '' },'FontSize',8)

%Plotter vertikale hjelpelinjer
dBmin=-10;
dBmax=70+dBmin;

plot([100 100],[dBmin+0.8 dBmax-0.7],'k:','Color',[0.6 0.6 0.6])
plot([3150 3150],[dBmin+0.8 dBmax-0.7],'k:','Color',[0.6 0.6 0.6])

plot([63 63],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([125 125],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([250 250],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([500 500],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([1000 1000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([2000 2000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([4000 4000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])

%Plotter horisontale hjelpelinjer
for i=1:dBmax/10-dBmin/10-1,
   plot([50 5000],[dBmax-i*10 dBmax-i*10],'Color',[0.6 0.6 0.6])
end
   