%Jason Cambridge
%Matlab code for EN12354

%close all
clear all
clc
f=[63,125,250,500,1000,2000,4000];
frd=[ 10 12.5 16 20 25 31.5 40 50 63 80 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 6300 8000 10000 12500 16000 20000];

f2=[ 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 ];
r4mm = [23 23 24 24 24 25 27 27 29 32 32 32 34 31 29 24];
r6mm = [22 25 26 28 27 27 28 29 31 31 34 34 31 29 24 28];
r10mm = [29 33 30 29 31 30 31 32 34 35 32 26 28 32 35 38];
%********************EN12354 Data**************************
%EnC260mm=[43,42,51,59,67,74,75];
%EnLC120mm=[33,36,34,35,44,53,56];

l1 = 1.15;  %sidekant a
l2 = 1.15;  %sidekant b
S = l1*l2;

po = 1.2;     %tetthet luft
co = 340;     %hastighet luft

rho = 2500;   %tetthet glass
t = 0.004;    %tykkelse p glasset
m1 = rho*t      %flatetetthet
vlong=5300; %blgehastighet glass
   %tykkelse glass
fc=(co^2/(1.8*vlong*t));                %grensefrekvensen  
E=(12*rho)./((fc.*2.*pi.*t)./(co^2))^2; %

B=E*t^3/12;
Cb=((B.*2.*pi.*frd)./(rho.*S)).^0.25;
bL=Cb./frd;
nt=0.01;  %tapsfaktor 0.045 for 10 mm

%************Radiation Factor************************
for s=1:length(frd)
ko(s)=(2.*pi.*frd(s))./340;
V(s)=-0.964-(0.5+(l2/(pi.*l1))).*log((l2/l1))+...
(5.*l2/(2.*pi.*l1))-(1./(4.*pi.*l1.*l2.*ko(s).^2));
sigmaf(s)=0.5.*(log(ko(s).*sqrt(l1*l2))-V(s));
if sigmaf(s)>2
sigmaf(s)=2;
end
end
%************Crtical frequency************************
fp=vlong/(5.5*t);%from correction term
fc2=fc*(4.05*((t.*frd)./vlong)+sqrt(1+(4.05*((t.*frd)./vlong))));
fc3=2.*fc.*((frd./fp).^3);
fcrt=ones(1,length(frd))*fc;
for n=1:length(frd);
if frd(n)>fc & frd(n)<fp
fcrt(n)=fc2(n);
elseif frd(n)>fc & frd(n)>fp
fcrt(n)=fc3(n);
end
end
%***************Determination of Sigma**********************
sigma1=1./(sqrt(1-fcrt./frd));
sigma2=4*l1*l2*(frd./co).^2;
sigma3=sqrt((2.*pi.*frd.*(l1+l2))/(16*co));
f11=(co.^2)./(4.*fcrt).*(1/l1^2+1/l2^2);
lambda=sqrt(frd./fcrt);
for m=1:length(frd)
delta1(m)=(((1-lambda(m).^2).*log((1+lambda(m))/(1-lambda(m)))...
+2.*lambda(m)))./((4*pi^2).*((1-lambda(m).^2).^1.5));
if frd(m)>fcrt(m)/2
delta2(m)=0;
else
delta2(m)=(8.*co.^2.*(1-2.*lambda(m).^2))./(fcrt(m)...
.^2.*pi^4.*l1.*l2.*lambda(m).*sqrt(1-lambda(m).^2))
end
sigma4(m)=(2*(l1+l2))/((l1*l2)).*((co/fcrt(m)).*delta1(m))+delta2(m);
end
for n=1:length(frd)
if f11(n)<=fcrt(n)./2 & frd(n)>=fcrt(n)
sigma(n)=sigma1(n);
elseif f11(n)<=fcrt(n)./2 & frd(n)<fcrt(n)
sigma(n)=sigma4(n);
elseif f11(n)<=fcrt(n)./2 & f11>frd(n) & sigma(n)>sigma2(n)
sigma(n)=sigma2(n)
end
if f11(n)>fcrt(n)./2 & frd(n)<fcrt(n) & sigma2(n) <sigma3(n)
    sigma(n)=sigma2(n);
elseif f11(n)>fcrt(n)/2 & frd(n)>fcrt(n) & sigma1(n)<sigma3(n)
sigma(n) =sigma1(n);
elseif f11(n)>fcrt(n)/2
sigma(n) =sigma3(n);
end
end
for n=1:length(frd)
if sigma(n)>2
sigma(n)=2;
end
end
%**************Evaluation Transmission factor**********
ntot=nt+(m1./(485.*sqrt(frd)));
ntot3=nt+(m1./(485.*sqrt(f)));

X=sqrt(31.1/fc);
Y=44.3*(fc/m1);

alpha=1/3*((2*sqrt(X*Y)*(1+X)*(1+Y))./(X*(1+Y)^2+2*Y*(1+X^2)))^2;
alphak=alpha*(1-0.9999*alpha);
S=t*l1;
ntot2=nt+((2.*po.*co.*sigma)./(2.*pi.*frd.*m1))...
+(co./(pi^2*S*sqrt(frd.*fcrt))*(((2*t+2*l1)*alphak)*2+((2*t+2*l2)*alphak)*2));
for n=1:length(frd)
    if frd(n)>(fcrt(n)+0.15*fcrt(n))
        T(n)=(((2*po*co)./(2.*pi.*frd(n)*m1)).^2).*...
        ((pi.*fcrt(n).*sigma(n).^2)./(2.*frd(n).*ntot(n)));
    elseif frd(n)>=(fcrt(n)-0.15*fcrt(n)) & frd(n)<=(fcrt(n)+0.1*fcrt(n)) 
        T(n)=(((2*po*co)./(2.*pi.*frd(n)*m1)).^2).*((pi*sigma(n).^2)./(2*ntot(n)));
    elseif frd(n)<(fcrt(n)-0.15*fcrt(n) )   
        T(n)=(((2*po*co)./(2.*pi.*frd(n)*m1)).^2).*(2.*sigmaf(n)+((l1+l2)^2)/(l1^2+l2^2)...
        *sqrt(fcrt(n)./frd(n)).*((sigma(n).^2)./ntot(n)));
    end
end
R=-10*log10(T);

no=5;
figure('Position',[100 100 500 500*(13.5/11.2)/6*no*(13.5/11.2)/(14.65/11.5)],'Color',[1 1 1]);
semilogx(frd,R,'r')
hold on
semilogx(f2,r4mm,'b')
axis([50 5000 0 50])  ;
legend('beregnet','mlt',2);
xlabel('Frekvens [Hz]','FontWeight','normal','FontSize',20);
ylabel('Reduksjonstall [dB]','FontWeight','normal','FontSize',20);
title('Reduksjonstall for enkeltpanel','FontWeight','normal','FontSize',24);
set(gca,'FontSize',8);
set(gca,'XTick',[ 50 63 80 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 ]);
set(gca,'XTickLabel',{ '50' '' '63' '' '' '125' '' '' '250' '' '' '500' '' '' '1000' '' '' '2000' '' '' '4000' '' },'FontSize',8);

%Plotter vertikale hjelpelinjer
dBmin=-10;
dBmax=70+dBmin;

plot([100 100],[dBmin+0.8 dBmax-0.7],'k:','Color',[0.6 0.6 0.6])
plot([3150 3150],[dBmin+0.8 dBmax-0.7],'k:','Color',[0.6 0.6 0.6])

plot([63 63],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([125 125],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([250 250],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([500 500],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([1000 1000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([2000 2000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([4000 4000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])

%Plotter horisontale hjelpelinjer
for i=1:dBmax/10-dBmin/10-1,
   plot([50 5000],[dBmax-i*10 dBmax-i*10],'Color',[0.6 0.6 0.6]);
end
   