clear all;
close all;
clc;

f       =   [  100  125  160  200  250  315  400  500  630  800  1000 1250 1600 2000 2500 3150] ;
Ctr     =   [	-20	-20	-18	-16	-15	-14	-13	-12	-11	-9	-8	-9	-10	-11	-13	-15	]
C       =   [	-29	-26	-23	-21	-19	-17	-15	-13	-12	-11	-10	-9	-9	-9	-9	-9	]

no=5;
figure('Position',[100 100 500 500*(13.5/11.2)/6*no*(13.5/11.2)/(14.65/11.5)],'Color',[1 1 1]);
%Plotter horisontale hjelpelinjer

temp = 0
for (i=1:1:length(Ctr));
    temp = temp + 10^(Ctr(i)/10)
end
temp= 10*log10(temp)

h = semilogx(f,C,'r');
hold on
g = semilogx(f,Ctr);
hold on
legend('C-korreksjon', 'Ctr-korreksjon',2);
 
axis([100 3150 -35 0])  
xlabel('Frekvens [Hz]','FontWeight','normal','FontSize',20)
ylabel('Korreksjon [dB]','FontWeight','normal','FontSize',20)
title('Lydspektre for omgjringstall henhold til ISO 717-1','FontWeight','normal','FontSize',24)
set(gca,'FontSize',8)
set(gca,'XTick',[50 63 80 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000])
set(gca,'XTickLabel',{ '' '63' '' '' '125' '' '' '250' '' '' '500' '' '' '1000' '' '' '2000' '' '' '4000' ''},'FontSize',8)
%Plotter vertikale hjelpelinjer
%Plotter vertikale hjelpelinjer
dBmin=-50;
dBmax=0;

plot([100 100],[dBmin+0.8 dBmax-0.7],'k:','Color',[0.6 0.6 0.6])
plot([3150 3150],[dBmin+0.8 dBmax-0.7],'k:','Color',[0.6 0.6 0.6])

plot([63 63],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([125 125],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([250 250],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([500 500],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([1000 1000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([2000 2000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])
plot([4000 4000],[dBmin+0.8 dBmax-0.7],'Color',[0.6 0.6 0.6])

for i=1:dBmax/10-dBmin/10-1,
   plot([100 3150],[dBmax-i*10 dBmax-i*10],'Color',[0.6 0.6 0.6])
end
