clear all;
%close all;
clc;
%%Plotting av koinsidensfrekvensen 
%
%  
%Mlinger utfrt i henhold til ISO 9614-2
%
% Knut Haugen 2006
%f       =   [50    63   80  100  125  160  200  250  315  400  500  630  800  1000 1250 1600 2000 2500 3150 4000 5000];

%Figure output
no=5;
figure('Position',[100 100 500 500*(13.5/11.2)/6*no*(13.5/11.2)/(14.65/11.5)],'Color',[1 1 1]);

%avstanden mellom rutene
s = 0.00:0.001:0.02;

fd = 60*sqrt((2.5*4+2.5*4)./(2.5*4*2.5*4*s)) % Bies and hansen: empirical const=  sqrt(1.8)*fd
plot(fd,s,'r');
hold on
fd2 = 60* sqrt((2.5*8+2.5*4)./(2.5*8*2.5*4*s));
plot(fd2,s,'b');
fd3 = 60* sqrt((2.5*6+2.5*4)./(2.5*6*2.5*4*s));
plot(fd3,s,'g');
fd4 = 60* sqrt((2.5*10+2.5*4)./(2.5*10*2.5*4*s));
plot(fd4,s,'k'); %m, c, k, y
legend('4-XX-4','4[1]4-XX-4','6-XX-4','10-XX-4')



xlabel('Frekvens [Hz]','FontWeight','normal','FontSize',12)
ylabel('Avstand mellom rutene [mm]','FontWeight','normal','FontSize',12)
title('Dobbeltveggresonans for to-lags vindusruter','FontWeight','normal','FontSize',14)
set(gca,'FontSize',8)
set(gca,'YTick',[0 0.002 0.004 0.006 0.008 0.01 0.012 0.014 0.016 0.018 0.02])
set(gca,'YTickLabel',{'0' '2' '4' '6' '8' '10' '12' '14' '16' '18' '20' },'FontSize',8)

grid on
