clear all;
close all;
clc;
%%Plotting av koinsidensfrekvensen 
%
%  
%Analytiske beregninger for lydisolerende beregninger til vindusglass 
%
% Knut Haugen 2006
f       =   [50    63   80  100  125  160  200  250  315  400  500  630  800  1000 1250 1600 2000 2500 3150 4000 5000];
c = 340;
d = 2500;
E = 60*10^(9);%10^(9);
p = 0.3;

%Tykkelsen til rutene
h = 0.003:0.001:0.008;

%Figure output
no=5;
figure('Position',[100 100 500 500*(13.5/11.2)/6*no*(13.5/11.2)/(14.65/11.5)],'Color',[1 1 1]);

%Regner ut koinsidensfrekvensen:
fc = (c^2./ (1.81*h))*sqrt((d*(1-p^2)) / E)
%fc2 = ((c^2)/ (2*pi))*sqrt((12*d*(1-p^2)) ./ (E.*h.*h))
plot(fc,h,'r')
ylabel('Glasstykkelsen [mm]','FontWeight','normal','FontSize',12)
xlabel('Frekvens [Hz]','FontWeight','normal','FontSize',12)
title('Grensefrekvens for forskjellige glasstykkelser','FontWeight','normal','FontSize',14)
set(gca,'FontSize',8)
set(gca,'YTick',[0.003 0.0035 0.004 0.0045 0.005 0.0055 0.006 0.0065 0.007 0.0075 0.008])
set(gca,'YTickLabel',{'3.0' '3.5' '4.0' '4.5' '5.0' '5.5' '6.0' '6.5' '7.0' '7.5' '8.0' },'FontSize',8)
grid on

grid on
figure('Position',[100 100 500 500*(13.5/11.2)/6*no*(13.5/11.2)/(14.65/11.5)],'Color',[1 1 1]);

%vindusdimensjoner m1
m1a = 1.48;
m1b = 1.23;
h1 = 0.009;
m1 =  h1 * d ;

%vindusdimensjoner m2
m2a = m1a;
m2b = m1b;
h2 = 0.004;
m2 =  h2 * d ;

%vindusdimensjoner m3
m3a = m1a;
m3b = m1b;
h3 = 0.004;
m3 =  h3 * d;


%avstanden mellom rutene
s = 0.00:0.001:0.08;

%dobbeltveggresonansen
fd = 60* sqrt((m1+m2)./(m1*m2*s));
%s= 0.012;
%fd = 30*sqrt((m1+m2)/(m1*m2)) * (3/2) * s^(-5/2) 

plot(fd,s,'r');
hold on
fd2 = 60* sqrt((2.5*3+2.5*3)./(2.5*3*2.5*3*s));
plot(fd2,s,'b');
fd2 = 60* sqrt((2.5*6+2.5*4)./(2.5*6*2.5*4*s));
plot(fd2,s,'g');
fd2 = 60* sqrt((2.5*10+2.5*4)./(2.5*10*2.5*4*s));
plot(fd2,s,'k'); %m, c, k, y
legend('4-XX-4','3-XX-3','6-XX-4','10-XX-4')
ylabel('Avstand mellom rutene [mm]','FontWeight','normal','FontSize',12)
xlabel('Frekvens [Hz]','FontWeight','normal','FontSize',12)
title('Dobbeltveggresonans for to-lags isolerruter','FontWeight','normal','FontSize',14)
set(gca,'FontSize',8)
set(gca,'YTick',[0.010 0.02 0.03 0.04 0.05 0.06 0.07 0.08])
set(gca,'YTickLabel',{'10' '20' '30' '40' '50' '60' '70' '80' },'FontSize',8)
grid on

