clear all;
close all;
clc;
%%Plotting av koinsidensfrekvensen 
%
%  
%Analytiske beregninger for lydisolerende beregninger til vindusglass 
%
% Knut Haugen 2006
f       =   [8 10 12.5 16 20 25 31.5 40 50 63 80 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 6300 8000 10000 12500 16000 20000];
ca = 340;

% romdimensjoner
a = 2;
b = 2,15;
c = 2;

%Regner ut panelets naturlige egefrekvenser og modeformer
%Euler's thin plate approximation for regular geometrices
%Approx: Simply-supported, rectangular, thin, isotropic plate
lengthn = 5;
lengthm = 5;
lengtho = 5;
for (n=1:1:lengthn )
    for (m=1:1:lengthm)
        for (o=1:1:lengtho)
            fnm(n,m,o) = ca/2 * sqrt((n/a)^2 + (m/b)^2 +(o/c)^2);
        end
    end
end

%Sorterer modearrayet p en vector
list = fnm(:);
list = sort(transpose(list));

%Finner hvilket frekevensbnd moden havner i og lagrer antallet i vector
mtetthet = zeros(1,length(f));
delta = ((2^(1/3)-1)/(2^(1/6)));
for(i=1:1:length(list))
    for(j=1:1:length(f))
        deltaf = delta*f(j)/2;
        if((list(i) > (f(j)-deltaf) ) && (list(i) < (f(j)+deltaf)))
            mtetthet(j) = mtetthet(j)+1;
        end
    end
end

%Plotter modefordelingen i 1/3 oktavbnd
figure('Position',[100 100 500 500*(13.5/11.2)/6*5*(13.5/11.2)/(14.65/11.5)],'Color',[1 1 1]);
plot(f,mtetthet)
axis([0 500 0 30])  
xlabel('Frekvens [Hz]','FontWeight','normal','FontSize',12)
ylabel('Antall moder','FontWeight','normal','FontSize',12)
title('Modefordeling i frekvensbnd','FontWeight','normal','FontSize',14)
set(gca,'XScale','LOG')
%set(gca,'FontSize',8)
y=1:5:100;
set(gca,'YTick',y);
set(gca,'XTick',[ 8 10 12.5 16 20 25 31.5 40 50 63 80 100 125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 6300 8000 10000 12500 16000 20000]);
%set(gca,'XTickLabel',{ '8' '' '' '16' '' '' '31,5' '' '' '63' '' '' '125' '' '' '250' '' '' '500' '' '' '1000' '' '' '2000' '' '' '4000' '' '' '8000' '' '' '16000' ''},'FontSize',8)


   
